; Bilinear filtering and real Phongs shading pararell.
; Thanks to authors of 3dica tutorial.
; Implemented in FASM by Maciej Guba.
; http://macgub.co.pl

ROUND2 equ 10

;----Procedure render Phongs shaded triangle with z coord
;----interpolation ( Catmull alghoritm ), each pixel is -
;----covered by texture using bilinear filtering.--------

; first stage - look at 'glass_tex_tri' proc

r_phg_bf_line_z:
; in:
;    xmm0 - normal vector 1
;    xmm1 - normal vect 2
;    xmm3 - lo -> hi tx1, ty1, z1 coords as dwords float
;    xmm5 - lo -> hi tx2, ty2, z2 coords as dwords float
;    xmm2 - lo -> hi y_min, y_max, x_min, x_max
;           as dword integers
;    xmm4 - normalized light vector
;    eax - x1
;    ebx - x2
;    ecx - y
;    edi - screen buffer
;    esi - z buffer filled with dd floats
;    edx - texture pointer (handle)
;    xmm6 - lowest dword x_res as integer

   push  ebp
   mov   ebp,esp
   sub   esp,220

   and   ebp,0xfffffff0

 .n1  equ [ebp-16]
 .n2  equ [ebp-32]
; .lv  equ [ebp-48]
 .lx1 equ [ebp-52]
 .lx2 equ [ebp-56]
 .x_res  equ [ebp-60]
 .y      equ [ebp-64]
 .screen equ [ebp-68]
 .zbuff  equ [ebp-72]
 .x_max  equ [ebp-74]
 .x_min  equ [ebp-76]
 .y_max  equ [ebp-78]
 .y_min  equ [ebp-80]
 .dn     equ [ebp-96]
 .yd     equ [ebp-100]
 .xd     equ [ebp-104]
 .yf     equ [ebp-108]
 .xf     equ [ebp-112]

 .cnv    equ [ebp-128]
 .z1     equ [ebp-136]
 .ty1    equ [ebp-140]
 .tx1    equ [ebp-144]
 .z2     equ [ebp-152]
 .ty2    equ [ebp-156]
 .tx2    equ [ebp-160]
 .cz     equ [ebp-168]
 .cty    equ [ebp-172]
 .ctx    equ [ebp-176]
 .dz     equ [ebp-184]
 .dty    equ [ebp-188]
 .dtx    equ [ebp-192]
; .th_on  equ [ebp-208]
 .tx_ptr equ [ebp-196]



        mov    .y,ecx
        packssdw xmm2,xmm2
        movq   .y_min,xmm2
        cmp    cx,.y_min
        jl     .end_line
        cmp    cx,.y_max
        jge    .end_line          ;

        cmp     eax,ebx
        je      .end_line
        jl      @f
        xchg    eax,ebx
        movaps  xmm7,xmm0
        movaps  xmm0,xmm1
        movaps  xmm1,xmm7
        movaps  xmm7,xmm3
        movaps  xmm3,xmm5
        movaps  xmm5,xmm7
   @@:

        cmp     ax,.x_max
        jge     .end_line
        cmp     bx,.x_min
        jle     .end_line
     ;   movaps  .lv,xmm4
        movaps  .n1,xmm0
        movaps  .n2,xmm1
        mov     .lx1,eax
        mov     .lx2,ebx
        movaps  .tx1,xmm3
        movaps  .tx2,xmm5
        movd    .x_res,xmm6
        mov     .tx_ptr,edx
        sub     ebx,eax
        cvtsi2ss xmm7,ebx
        rcpss    xmm7,xmm7
        shufps   xmm7,xmm7,0
        subps    xmm1,xmm0
        mulps    xmm1,xmm7
        movaps   .dn,xmm1
        subps    xmm5,xmm3
        mulps    xmm5,xmm7
        movaps   .dtx,xmm5



        mov      ebx,.lx1
        cmp      bx,.x_min     ; clipping on function4
        jge      @f
        movzx    eax,word .x_min
        sub      eax,ebx
        cvtsi2ss xmm7,eax
        shufps   xmm7,xmm7,0
        mulps    xmm5,xmm7
        mulps    xmm1,xmm7
        addps    xmm5,.tx1
        addps    xmm1,.n1
        movsx    eax,word .x_min
        movaps   .tx1,xmm5
        movaps   .n1,xmm1
        mov      dword .lx1,eax

      @@:
        movzx   eax,word .x_max
        cmp     .lx2,eax
        jl      @f
        mov     .lx2,eax
      @@:
        mov     eax,.x_res
        mul     dword .y
        add     eax,.lx1
        shl     eax,2
        add     edi,eax
        add     esi,eax

        mov     ecx,.lx2
        sub     ecx,.lx1
        movaps  xmm2,.tx1
;        movaps  xmm7,[the_one]
;        movaps  .th_on,xmm7

   .ddraw:
        movhlps  xmm7,xmm2
        cmpnltss xmm7,dword[esi]
        movd     eax,xmm7
        or       eax,eax
        jnz      .skip
        xorps    xmm5,xmm5
        movhlps  xmm7,xmm2
        movss    [esi],xmm7
        movaps   xmm7,.n1  ;xmm0
        mulps    xmm7,xmm7 ; normalize
        haddps   xmm7,xmm7
        haddps   xmm7,xmm7
        rsqrtps  xmm7,xmm7
        mulps    xmm7,.n1   ;xmm0
        movaps   .cnv,xmm7

        movaps   xmm6,xmm2
        minps    xmm6,[tex_m2]  ;    float  TEX_X-2,TEX_Y-2
        cvttps2dq xmm7,xmm6
        cvtdq2ps xmm4,xmm7
        subps    xmm6,xmm4
        movlps   .xf,xmm6
     ;    movaps   xmm5,.lv
        mov      eax,lights_aligned   ; global
      @@:
        xorps    xmm1,xmm1
        movaps   xmm0,[eax] ; calc multple lights
        mulps    xmm0,.cnv  ;.lv  ; last dword should be zeroed
        haddps   xmm0,xmm0
        haddps   xmm0,xmm0
   ;     andps    xmm0,[abs_val]  ;calc absolute value
        maxps    xmm0,xmm1 ;[the_zero]
        movaps   xmm1,xmm0
        mulps    xmm0,[eax+16]
        mulps    xmm1,xmm1
        mulps    xmm1,xmm1
        mulps    xmm1,xmm1
        mulps    xmm1,xmm1
        mulps    xmm1,[eax+48]
        addps    xmm0,xmm1
        maxps    xmm5,xmm0
        add      eax,64
        cmp      eax,lights_aligned_end
        jnz      @b
        minps    xmm5,[mask_255f]

          ; texture coords work
        movd     eax,xmm7
        psrldq   xmm7,4
        movd     ebx,xmm7
        shl      ebx,TEX_SHIFT
        add      eax,ebx
        shl      eax,2
        add      eax,.tx_ptr
        mov      ebx,eax
        add      ebx,TEX_X*4
        movd     xmm7,[eax]
        movd     xmm6,[eax+4]
        movd     xmm4,[ebx]
        movd     xmm3,[ebx+4]
        punpcklbw xmm7,xmm6 ;xmm7 r1 r2 g1 g2 b1 b2
        punpcklbw xmm4,xmm3 ;xmm4 r3 r4 g3 g4 b3 b4
        punpcklwd xmm7,xmm4 ;xmm7 r1 r2 r3 r4 g1 g2 g3 g4 ...
        movdqa    xmm6,xmm7
        movdqa    xmm4,xmm7
        psrldq    xmm6,4
        psrldq    xmm4,8

        pxor      xmm3,xmm3
        punpcklbw xmm7,xmm3
        punpcklbw xmm6,xmm3
        punpcklbw xmm4,xmm3
        punpcklwd xmm7,xmm3
        punpcklwd xmm6,xmm3
        punpcklwd xmm4,xmm3


     ; calc w .........
        movlps   xmm3,[the_one]  ;  broadcasted dword 1.0
        cvtdq2ps  xmm7,xmm7
        subps    xmm3,.xf
        cvtdq2ps  xmm6,xmm6
        movhps   xmm3,.xf
        cvtdq2ps  xmm4,xmm4
        movaps   xmm1,xmm3  ; 1-xf, 1-yf, xf, yf
        shufps   xmm3,xmm3,10001000b
        shufps   xmm1,xmm1,11110101b
        mulps    xmm3,xmm1

        mulps    xmm7,xmm3
        mulps    xmm6,xmm3
        mulps    xmm4,xmm3
        haddps   xmm7,xmm7  ; r
        haddps   xmm6,xmm6  ; g
        haddps   xmm4,xmm4  ; b
        haddps   xmm7,xmm7  ; r
        haddps   xmm6,xmm6  ; g
        haddps   xmm4,xmm4  ; b
        movlhps  xmm7,xmm6
        shufps   xmm7,xmm7,11101000b
        movlhps  xmm7,xmm4

        mulps    xmm5,xmm7
        cvtps2dq xmm5,xmm5
        psrld    xmm5,8
        packssdw xmm5,xmm5
        packuswb xmm5,xmm5
        movd     [edi],xmm5
     .skip:
        add      edi,4
        add      esi,4
        movaps   xmm0,.n1     ; cur normal
        addps    xmm0,.dn
        addps    xmm2,.dtx
        movaps   .n1,xmm0
    ;    loop     @b
        dec      ecx
        jnz      .ddraw

  .end_line:
        add      esp,220
        pop      ebp

ret
