
; fist stage (two loops) - see bump_tex.inc file


bump_line_z:
; proc render horizontal line with bump mapping
; bump tex standard calling convention
;	 xmm0 - .ty1, .tx1, .ey1, ex1
;	 xmm1 - .ty2, .tx2, .ey2, ex2
;	 xmm2 - .by1, .bx1, .z1, x1
;	 xmm3 - .by2, .bx2, .z2, x2

;--------------in: eax - x1
;--------------    ebx - x2
;--------------    edi - pointer to screen buffer
;stack - another parameters :


.y	equ  dword [ebp+4]
.bmap	equ  dword [ebp+8]	  ; bump map pointer
.emap	equ  dword [ebp+12]	  ; env map pointer
.z_buff equ  dword [ebp+16]	  ; z buffer
.tex_map equ dword [ebp+20]	 ; texture pointer
.y_min	equ  [ebp+24]
.y_max	equ  [ebp+26]


.x1	equ dword [ebp-4]
.x2	equ dword [ebp-8]
.dbx	equ dword [ebp-12]
.dby	equ	  [ebp-16]
.dex	equ dword [ebp-20]
.dey	equ	  [ebp-24]
.dz	equ dword [ebp-28]
.cbx	equ dword [ebp-32]
.cby	equ	  [ebp-36]
.cex	equ dword [ebp-40]
.cey	equ	  [ebp-44]
.cz	equ dword [ebp-48]
.czbuff equ dword [ebp-52]


.z2	equ	  [ebp-60]
.z1	equ	  [ebp-64]

	mov	ebp,esp

	mov	ecx,.y
	movzx	edx,word .y_min
	cmp	ecx,edx
	jl	.bl_end
	cmp	cx,word .y_max	;[yres_var]  ;SIZE_Y
	jge	.bl_end

	  movaps  xmm5,xmm2
	  movhlps xmm5,xmm3  ; l-h: cz2, xx, cz1, xx
	  pshufd  xmm5,xmm5, 11110010b
	 ; xm2 - z1, z2
	  movhlps xmm0,xmm0
	  movlhps xmm0,xmm2
	  movhlps xmm1,xmm1
	  movlhps xmm1,xmm3



	cmp	eax,ebx
	jl	.bl_ok
	je	.bl_end

	xchg	eax,ebx
	movaps xmm7,xmm0

	movaps xmm0,xmm1

	movaps xmm1,xmm7
	pshufd	xmm5,xmm5,11100001b



  .bl_ok:
	 ; xm2 - z1, z2

	push	   eax
	push	   ebx		 ;store x1, x2
	sub	   esp,70
	movq	  .z1,xmm5
	movdqu	  .cey,xmm0
	movd	  .cz,xmm5

	movzx	eax,[xres_var]
	cmp	.x1,eax  ;SIZE_X
	jge	.bl_end
	cmp	.x2,0
	jle	.bl_end

	mov	ebx,.x2
	sub	ebx,.x1


       cvtsi2ss  xmm3,ebx	     ;rcps
       shufps	 xmm3,xmm3,0
       rcpps	 xmm3,xmm3
       psubd	 xmm1,xmm0
       cvtdq2ps  xmm1,xmm1

       mulps	 xmm1,xmm3
       cvtps2dq  xmm1,xmm1
       movdqu	 .dey,xmm1


	mov	eax,.z2        ; calc .dz
	sub	eax,.z1
	cdq
	idiv	ebx
	mov	.dz,eax


	cmp	.x1,0	      ; set correctly begin variable
	jge	@f	      ; CLIPPING ON FUNCTION
			      ; cutting triangle exceedes screen
	mov	ebx,.x1
	neg	ebx
	imul	ebx	      ; eax = .dz * abs(.x1)
	add	.cz,eax
	mov	.x1,0

	mov	eax,.dbx
	imul	ebx
	add    .cbx,eax

	mov	eax,.dby
	imul	ebx
	add	.cby,eax

	mov	eax,.dex
	imul	ebx
	add	.cex,eax

	mov	eax,.dey
	imul	ebx
	add	.cey,eax
      @@:
	movzx	eax,[xres_var]
	cmp	.x2,eax ;SIZE_X
	jl	@f
	mov	.x2,eax  ;SIZE_X
      @@:
	movzx	eax,[xres_var] ;SIZE_X	     ;calc memory begin in buffers
	mov	ebx,.y
	mul	ebx
	mov	ebx,.x1
	add	eax,ebx
	mov	ebx,eax
	mov	esi,.z_buff	  ; z-buffer filled with dd variables
	shl	ebx,2
	add	esi,ebx
	add	edi,ebx

	mov	ecx,.x2
	sub	ecx,.x1
	; init current variables

	mov	.czbuff,esi

	movups	 xmm6,.dey
	movups	 xmm5,.cey

	mov    eax,TEXTURE_SIZE
	movd   xmm1,eax
	shufps xmm1,xmm1,0
	push   dword  TEX_X
	push   dword  -TEX_X
	push   dword  1
	push   dword  -1
	movups xmm2,[esp]
	movd   xmm3,.bmap
	shufps xmm3,xmm3,0


     .draw:
    ; if TEX = SHIFTING   ;bump drawing only in shifting mode
	mov	esi,.czbuff	 ; .czbuff current address in buffer
	mov	ebx,.cz 	 ; .cz - cur z position
	cmp	ebx,dword[esi]
	jge	.skip

	movhlps xmm0,xmm5
	psrld	xmm0,ROUND
	movd	eax,xmm0
	psrlq	xmm0,32
	movd	esi,xmm0

	shl	eax,TEX_SHIFT	;-
	add	esi,eax 	;-  ; esi - current bump map index

	movd	xmm0,esi
	shufps	xmm0,xmm0,0
	paddd	xmm0,xmm2
	pand	xmm0,xmm1
	paddd	xmm0,xmm3

	movd	ebx,xmm0
	movzx	eax,byte[ebx]
	movhlps xmm7,xmm0
	psrldq	xmm0,4
	movd	ebx,xmm0
	movzx	ebx,byte[ebx]
	sub	eax,ebx

     ;	 psrldq  xmm0,4
	movd	ebx,xmm7
	movzx	edx, byte[ebx]

	psrldq	xmm7,4
	movd	ebx,xmm7
	movzx	ebx, byte [ebx]
	sub	edx,ebx
;

     ;	eax - horizontal sub
     ;	edx - vertical	 sub


	movq	xmm0,xmm5	 ; mm5 - copy of cur env coords
	psrld	xmm0,ROUND
	movd	ebx,xmm0
	psrlq	xmm0,32
	add	eax,ebx
	movd	ebx,xmm0
	add	edx,ebx


	shl	edx,TEX_SHIFT
	add	edx,eax
	and	edx,TEXTURE_SIZE
	lea	esi,[edx*4]
	add	esi,.emap
	movsd
	mov	ebx,.cz
	mov	esi,.czbuff
	mov	dword[esi],ebx
	jmp	.sk
     .skip:
	add	edi,4
      .sk:
	add	.czbuff,4
	paddd	xmm5,xmm6
	mov	eax,.dz
	add	.cz,eax
     ;	 loop	 .draw
	dec	 ecx
	jnz	.draw

  .bl_end:
	mov	esp,ebp
ret 24	;60
