
ROUND equ 8
;------- Big thanks to Mikolaj Feliks for absolutely great--------------
;------- DOS 13h mode demos --------------------------------------------
;------- Procedure draws bump triangle with texture, I use -------------
;--------Catmull Z-buffer algorithm- (Z coordinate interpolation)-------
;--------I calc texture pixel by this way: col1*col2/256 ---------------
bump_tex_triangle_z:
;------------------in - eax - x1 shl 16 + y1 -----------
;---------------------- ebx - x2 shl 16 + y2 -----------
;---------------------- ecx - x3 shl 16 + y3 -----------
;---------------------- edx - pointer to bump map-------
;---------------------- esi - pointer to env map--------
;---------------------- edi - pointer to screen buffer--
;----------------------- xmm7 - dword horizontal line --
;---------------------- 	proc adress ------------
;---------------------- stack : bump coordinates--------
;---------------------- 	environment coordinates-
;---------------------- 	Z position coordinates--
;---------------------- 	pointer to Z buffer-----
;---------------------- 	pointer to texture------
;---------------------- 	texture coordinates-----
;-- Z-buffer - filled with coordinates as dword --------
;-- (Z coor. as word) shl ROUND ------------------------

.b_x1	equ ebp+8   ; procedure don't save registers !!!
.b_y1	equ ebp+10  ; each coordinate as word
.b_x2	equ ebp+12
.b_y2	equ ebp+14	 ; b - bump map coords
.b_x3	equ ebp+16	 ; e - env map coords
.b_y3	equ ebp+18
.e_x1	equ ebp+20
.e_y1	equ ebp+22
.e_x2	equ ebp+24
.e_y2	equ ebp+26
.e_x3	equ ebp+28
.e_y3	equ ebp+30
.z1	equ [ebp+32]
.z2	equ word[ebp+34]
.z3	equ word[ebp+36]
.z_buff equ [ebp+38]	   ; pointer to Z-buffer
.tex_ptr equ dword[ebp+42]	; ptr to texture
.t_x1	equ ebp+46		; texture coords
.t_y1	equ ebp+48
.t_x2	equ ebp+50
.t_y2	equ ebp+52
.t_x3	equ ebp+54
.t_y3	equ ebp+56
.y_min	equ [ebp+58]
.y_max	equ word[ebp+60]



.t_bmap equ dword[ebp-4]	; pointer to bump map
.t_emap equ dword[ebp-8]	; pointer to env map
.x1	equ word[ebp-10]
.y1	equ word[ebp-12]
.x2	equ word[ebp-14]
.y2	equ word[ebp-16]
.x3	equ [ebp-18]
.y3	equ [ebp-20]
.hlp1	equ [ebp-22]

.dx12	equ dword[ebp-24]
.dz12	equ	 [ebp-28]
.dbx12	equ dword[ebp-32]
.dby12	equ	 [ebp-36]
.dex12	equ dword[ebp-40]
.dey12	equ	 [ebp-44]
.dtx12	equ dword[ebp-48]
.dty12	equ	 [ebp-52]

.dx13  equ dword[ebp-52-4*1]
.dz13  equ	[ebp-52-4*2]
.dbx13 equ dword[ebp-52-4*3]
.dby13 equ	[ebp-52-4*4]
.dex13 equ dword[ebp-52-4*5]
.dey13 equ	[ebp-52-4*6]
.dtx13 equ dword[ebp-52-4*7]
.dty13 equ	[ebp-52-4*8]


.dx23  equ dword[ebp-(52+4*9)]
.dz23  equ	[ebp-(52+4*10)]
.dbx23 equ dword[ebp-(52+4*11)]
.dby23 equ	[ebp-(52+4*12)]
.dex23 equ dword[ebp-(52+4*13)]
.dey23 equ	[ebp-(52+4*14)]
.dtx23 equ dword[ebp-(52+4*15)]
.dty23 equ	[ebp-(52+4*16)]


.cx1	 equ dword[ebp-(52+4*17)]	  ; current variables
.cz1	 equ	  [ebp-(52+4*18)]

.cbx1	 equ dword[ebp-(52+4*19)]
.cby1	 equ	  [ebp-(52+4*20)]
.cby1_d  equ	  [edx]  ; to achive shorter adresses

.cex1	 equ dword[ebp-(52+4*21)]
.cey1	 equ	  [ebp-(52+4*22)]
.cey1_d  equ	  [edx-8]

.ctx1	 equ dword[ebp-(52+4*23)]
.ctx1_d  equ	  [edx-12]
.cty1	 equ	  [ebp-(52+4*24)]
.cty1_d  equ	  [edx-16]

.cx2	equ dword[ebp-(52+4*25)]
.cx2_d	equ	 [edx-20]
.cz2	equ	 [ebp-(52+4*26)]
.cz2_d	equ	 [edx-24]
.cbx2	equ dword[ebp-(52+4*27)]
.cbx2_d equ	 [edx-28]
.cby2	equ	 [ebp-(52+4*28)]
.cby2_d equ	 [edx-32]
.cex2	equ dword[ebp-(52+4*29)]
.cex2_d equ	 [edx-36]
.cey2	equ	 [ebp-(52+4*30)]
.cey2_d equ	 [edx-40]
.ctx2	equ dword[ebp-(52+4*31)]
.ctx2_d equ	 [edx-44]
.cty2	equ	 [ebp-(52+4*32)]
.cty2_d equ	 [edx-48]
.hor_proc_d  equ dword [edx-52]
.horiz_proc  equ [ebp-(52+4*33)]

       cld
       push    ebp
       mov     ebp,esp
       push    edx	  ; store bump map
       push    esi	  ; store e. map
       movups  xmm0,[.b_x1]
       movups  xmm1,[.e_x1]
       movq    xmm2,.z1
       movups  xmm3,[.t_x1]
       movq    xmm4,.z_buff
       movd    xmm5,.y_min



 .sort3:		  ; sort triangle coordinates...
       cmp     ax,bx
       jle     .sort1
       xchg    eax,ebx
       pshufd  xmm0,xmm0,11100001b
       pshufd  xmm1,xmm1,11100001b
       pshuflw xmm2,xmm2,11100001b
       pshufd  xmm3,xmm3,11100001b

 .sort1:
       cmp	bx,cx
       jle	.sort2
       xchg	ebx,ecx
       pshufd  xmm0,xmm0,11011000b
       pshufd  xmm1,xmm1,11011000b
       pshuflw xmm2,xmm2,11011000b
       pshufd  xmm3,xmm3,11011000b

       jmp	.sort3
 .sort2:

       push	eax	; store triangle coords in variables
       push	ebx
       push	ecx

       sub	esp,330
       movd	.horiz_proc,xmm7


       movups	[.b_x1],xmm0
       movups	[.e_x1],xmm1
       movq	.z1,xmm2
       movups	[.t_x1],xmm3
       movq	.z_buff,xmm4
       movd	.y_min,xmm5

       lea	 edx,.cby1
       pxor	 xmm6,xmm6
       movdqa	 xmm7,xmm1
       movlhps	 xmm7,xmm0
       pshufd	 xmm7,xmm7,11111000b
       pcmpgtw	 xmm6,xmm7
       punpcklwd xmm7,xmm6
       pshufd	 xmm7,xmm7,10110001b
       pslld	 xmm7,ROUND
       movdqu	 .cey2_d,xmm7
       movdqu	 .cey1_d,xmm7

    ;	movaps	  xmm7,xmm3
    ;	pslld	  xmm7,ROUND
    ;	movq	  .cty1,xmm7
    ;	movq	  .cty2,xmm7
	; int3


if 0	     ; no check - was previously


	movups	xmm0,.y3		; check if at last only fragment
	pand	xmm0,[draw_thread_mask] ; of triangle is in visable area
	movd	xmm1,.y_min
	packssdw xmm0,xmm0
	pshuflw xmm2,xmm1,01010101b
	pshuflw xmm1,xmm1,0
	movdqa	xmm3,xmm0
	pcmpgtw xmm3,xmm2
	pcmpgtw xmm0,xmm1
	pxor	xmm0,xmm3
	pmovmskb eax,xmm0
	and	al,00111111b
	or	al,al
	jz     .loop23_done

end if

       movdqu	xmm7,.hlp1
       psrld	xmm7,16
       movdqa	xmm6,xmm7
       pshufd	xmm7,xmm7,11000001b
       pshufd	xmm6,xmm6,11011010b
       psubd	xmm7,xmm6
       cvtdq2ps xmm7,xmm7
       rcpps	xmm7,xmm7

       mov	 eax,1 shl ROUND
       cvtsi2ss  xmm6,eax
       shufps	 xmm6,xmm6,0
       mulps	 xmm7,xmm6

       pxor	xmm6,xmm6
       movaps	xmm4,xmm0
       pshufd	xmm0,xmm0,11101001b
       pshufd	xmm4,xmm4,11010000b
       psubw	xmm0,xmm4
       ; xmm0  dwbx12 dwby12 dwbx13 dwby13 dwbx23 dwby23
       pcmpgtw	xmm6,xmm0
       movhlps	xmm4,xmm0
       movhlps	xmm5,xmm6

			    ; bumps
       punpcklwd xmm0,xmm6  ; xmm0 ddx12 ddy12 ddx13 ddy13
       punpcklwd xmm4,xmm5  ;
       cvtdq2ps  xmm0,xmm0
       cvtdq2ps  xmm4,xmm4

       movaps	 xmm6,xmm7
       shufps	 xmm7,xmm7,01010000b
       shufps	 xmm6,xmm6,10101010b

       mulps	 xmm0,xmm7   ; xmm0 dbx12 dby12 dbx13 dby13
       mulps	 xmm4,xmm6
       shufps	 xmm0,xmm0,10110001b
       cvtps2dq  xmm0,xmm0
       shufps	 xmm4,xmm4,11100001b
       cvtps2dq  xmm4,xmm4
       movlps	 .dby12,xmm0
       movhps	 .dby13,xmm0
       movlps	 .dby23,xmm4

       pxor	xmm5,xmm5
       movaps	xmm4,xmm1
       pshufd	xmm1,xmm1,11101001b
       pshufd	xmm4,xmm4,11010000b
       psubw	xmm1,xmm4
       ; xmm1  dwex12 dwey12 dwex13 dwey13 dwex23 dwey23
       pcmpgtw	xmm5,xmm1
       movhlps	xmm4,xmm1
       movhlps	xmm0,xmm5

       punpcklwd xmm1,xmm5
       punpcklwd xmm4,xmm0
       cvtdq2ps  xmm1,xmm1
       cvtdq2ps  xmm4,xmm4
       mulps	 xmm1,xmm7   ; xmm1 dex12 dey12 dex13 dey13
       mulps	 xmm4,xmm6

       shufps	 xmm1,xmm1,10110001b
       cvtps2dq  xmm1,xmm1
       shufps	 xmm4,xmm4,11100001b
       cvtps2dq  xmm4,xmm4
       movlps	 .dey12,xmm1
       movhps	 .dey13,xmm1
       movlps	 .dey23,xmm4

       pxor	xmm5,xmm5
       movaps	xmm4,xmm3
       pshufd	xmm3,xmm3,11101001b
       pshufd	xmm4,xmm4,11010000b
       psubw	xmm3,xmm4
       ; xmm3 -  dwtx12 dwty12 dwtx13 dwty13 dwtx23 dwty23
       pcmpgtw	xmm5,xmm3
       movhlps	xmm4,xmm3
       movhlps	xmm0,xmm5

       punpcklwd xmm3,xmm5
       punpcklwd xmm4,xmm0
       cvtdq2ps  xmm3,xmm3
       cvtdq2ps  xmm4,xmm4
       mulps	 xmm3,xmm7   ; xmm3 dtx12 dty12 dtx13 dty13
       mulps	 xmm4,xmm6

       shufps	 xmm3,xmm3,10110001b
       cvtps2dq  xmm3,xmm3
       shufps	 xmm4,xmm4,11100001b
       cvtps2dq  xmm4,xmm4
       movlps	 .dty12,xmm3
       movhps	 .dty13,xmm3
       movlps	 .dty23,xmm4



       pxor	 xmm5,xmm5
       movups	 xmm3,.x3
       pslld	 xmm3,16
       pshufd	 xmm3,xmm3,11000110b

       punpcklwd xmm2,xmm5
       por	 xmm3,xmm2
       movaps	 xmm4,xmm3

       pshufd	xmm3,xmm3,11101001b
       pshufd	xmm4,xmm4,11010000b
       psubw	xmm3,xmm4
       ; xmm3  dwz12 dw12 dwz13 dw13 dwz23 dw23
       pcmpgtw	xmm5,xmm3
       movhlps	xmm4,xmm3
       movhlps	xmm0,xmm5

       punpcklwd xmm3,xmm5
       punpcklwd xmm4,xmm0
       cvtdq2ps  xmm3,xmm3
       cvtdq2ps  xmm4,xmm4
       mulps	 xmm3,xmm7   ; xmm3 dz12 d12 dz13 d13
       mulps	 xmm4,xmm6



       cvtps2dq  xmm3,xmm3
       cvtps2dq  xmm4,xmm4
       movlps	 .dz12,xmm3
       movhps	 .dz13,xmm3
       movlps	 .dz23,xmm4

   .bt_dx23_done:
       lea	edx,.cby1

       movsx	eax,.x1
       shl	eax,ROUND

       mov	.cx1,eax
       mov	.cx2_d,eax

       movsx	ebx,word .z1
       shl	ebx,ROUND  ;CATMULL_SHIFT
       mov	.cz1,ebx
       mov	.cz2_d,ebx

       movsx	ecx,word[.t_x1]
       shl	ecx,ROUND
       mov	.ctx1_d,ecx
       mov	.ctx2_d,ecx

       movsx	ebx,word[.t_y1]
       shl	ebx,ROUND
       mov	.cty1_d,ebx
       mov	.cty2_d,ebx
       movdqu	xmm0,.cty1_d
       movdqu	xmm1,.cty2_d
       movdqu	xmm2,.cby1_d
       movdqu	xmm3,.cby2_d


       movsx	ecx,.y1
       cmp	cx,.y2
       jge	.loop12_done
  .loop12:

       call	.call_line
       movdqu	xmm0,.cty1_d
       movdqu	xmm1,.cty2_d
       movdqu	xmm2,.cby1_d
       movdqu	xmm3,.cby2_d

       movdqu	xmm4,.dty13
       movdqu	xmm5,.dty12
       movdqu	xmm6,.dby13
       movdqu	xmm7,.dby12

       paddd	xmm0,xmm4
       paddd	xmm1,xmm5
       paddd	xmm2,xmm6
       paddd	xmm3,xmm7

       movdqu  .cty1_d,xmm0
       movdqu  .cty2_d,xmm1
       movdqu  .cby1_d,xmm2
       movdqu  .cby2_d,xmm3

       inc	ecx
       cmp	cx,.y2
       jl	.loop12
    .loop12_done:

       movsx	ecx,.y2
       cmp	cx,.y3
       jge	.loop23_done


       movsx	eax,.z2
       shl	eax,CATMULL_SHIFT
       mov	.cz2_d,eax

       movsx	ebx,.x2
       shl	ebx,ROUND
       mov	.cx2_d,ebx

       movzx	eax,word[.b_x2]
       shl	eax,ROUND
       mov	.cbx2_d,eax

     ;	lea	 edx,.cby

       movzx	eax,word[.b_y2]
       shl	eax,ROUND
       mov	.cby2_d,eax

       movzx	ebx,word[.e_x2]
       shl	ebx,ROUND
       mov	.cex2_d,ebx

       movzx	eax,word[.e_y2]
       shl	eax,ROUND
       mov	.cey2_d,eax

       movzx	eax,word[.t_x2]
       shl	eax,ROUND
       mov	.ctx2_d,eax

       movzx	ebx,word[.t_y2]
       shl	ebx,ROUND
       mov	.cty2_d,ebx

       movdqu	xmm0,.cty1_d
       movdqu	xmm1,.cty2_d
       movdqu	xmm2,.cby1_d
       movdqu	xmm3,.cby2_d

     .loop23:
       call	.call_line

       movdqu	xmm0,.cty1_d
       movdqu	xmm1,.cty2_d
       movdqu	xmm2,.cby1_d
       movdqu	xmm3,.cby2_d

       movdqu	xmm4,.dty13
       movdqu	xmm5,.dty23
       movdqu	xmm6,.dby13
       movdqu	xmm7,.dby23

       paddd	xmm0,xmm4
       paddd	xmm1,xmm5
       paddd	xmm2,xmm6
       paddd	xmm3,xmm7

       movdqu  .cty1_d,xmm0
       movdqu  .cty2_d,xmm1
       movdqu  .cby1_d,xmm2
       movdqu  .cby2_d,xmm3


       inc	ecx
       cmp	cx,.y3
       jl	.loop23
    .loop23_done:

       mov	esp,ebp
       pop	ebp
ret   54



.call_line:

       pushad
       push	.y_max
       push	word .y_min
       push	 .tex_ptr
       push	dword .z_buff
       push	.t_emap
       push	.t_bmap
       push	ecx

       mov	eax,.cx1
       sar	eax,ROUND
       mov	ebx,.cx2
       sar	ebx,ROUND
     ;	mov	 edx,.horiz_proc
     ;	call	 edx
       call	.hor_proc_d
       popad

ret

bump_tex_line_z:
;	 xmm0 - .ty1, .tx1, .ey1, ex1
;	 xmm1 - .ty2, .tx2, .ey2, ex2
;	 xmm2 - .by1, .bx1, .z1, x1
;	 xmm3 - .by2, .bx2, .z2, x2
;
;--------------in: eax - x1
;--------------    ebx - x2
;--------------    edi - pointer to screen buffer

;stack - another parameters:

.y	equ  dword [ebp+4]
.bmap	equ  dword [ebp+8]	  ; bump map pointer
.emap	equ  dword [ebp+12]	  ; env map pointer
.z_buff equ  dword [ebp+16]	  ; z buffer
.tex_map equ dword [ebp+20]	 ; texture pointer
.y_min	equ  [ebp+24]
.y_max	equ  [ebp+26]



.x1	equ [ebp-4]
.x2	equ [ebp-8]
.dbx	equ [ebp-12]
.dby	equ [ebp-16]
.dex	equ [ebp-20]
.dey	equ [ebp-24]
.dz	equ [ebp-28]
.dtx	equ [ebp-32]
.dty	equ [ebp-36]

.cbx	equ [ebp-40]
.cby	equ [ebp-44]
.cex	equ [ebp-48]
.cey	equ [ebp-52]
.cz	equ [ebp-56]
.czbuff equ [ebp-60]
.ctx	equ [ebp-64]
.cty	equ [ebp-68]
.c_scr	equ [ebp-72]
.tsiz	equ [ebp-76]
.tex_x	equ dword[ebp-80]


	mov	ebp,esp

      ;  mov	 ecx,.y
      ;  movzx	 edx,word .y_min
	cmp	cx,.y_min
	jl	.bl_end
	cmp	cx,.y_max
	jge	.bl_end

	cmp	eax,ebx
	jl	.bl_ok
	je	.bl_end

	movaps xmm7,xmm0
	movaps xmm6,xmm2

	movaps xmm0,xmm1
	movaps xmm2,xmm3

	movaps xmm1,xmm7
	movaps xmm3,xmm6


	xchg	eax,ebx

  .bl_ok:

	push	eax
	push	ebx	      ;store x1, x2
	movzx	eax,[xres_var]
	cmp	dword .x1,eax  ;SIZE_X
	jge	.bl_end
	cmp	dword .x2,0
	jle	.bl_end

	mov	ebx,.x2
	sub	ebx,.x1


	sub	  esp,80

       mov	 .tsiz,dword TEXTURE_SIZE
       mov	 .tex_x,TEX_X
       cvtsi2ss  xmm4,ebx
       rcpss	 xmm4,xmm4
       shufps	 xmm4,xmm4,0

       psubd	 xmm1,xmm0
       psubd	 xmm3,xmm2
       movhps	 .cz,xmm2
       movhps	 .cey,xmm0
       movlps	 .cby,xmm2
       movlps	 .cty,xmm0
;	movaps	   xmm5,xmm0


       cvtdq2ps  xmm1,xmm1
       cvtdq2ps  xmm3,xmm3
       mulps	 xmm1,xmm4
       mulps	 xmm3,xmm4
       cvtps2dq  xmm1,xmm1
       cvtps2dq  xmm3,xmm3
       movhps	 .dz,xmm3
       movlps	 .dty,xmm1
;	movaps	  xmm4,xmm1
       movhps	 .dey,xmm1
       movlps	 .dby,xmm3



	xor	eax,eax
	cmp	dword .x1,eax  ;0	  ; set correctly begin variable
	jge	@f	      ; CLIPPING ON FUNCTION
			       ; cutting triangle exceedes screen

	mov	ebx,.x1
	neg	ebx

	mov	dword .x1,eax

	mov	eax,.dz
	imul	ebx	      ; eax = .dz * abs(.x1)
	add	.cz,eax


	mov	eax,.dbx
	imul	ebx
	add    .cbx,eax

	mov	eax,.dby
	imul	ebx
	add	.cby,eax

	mov	eax,.dex
	imul	ebx
	add	.cex,eax

	mov	eax,.dey
	imul	ebx
	add	.cey,eax

	mov	eax,.dtx
	imul	ebx
	add	.ctx,eax

	mov	eax,.dty
	imul	ebx
	add	.cty,eax

      @@:

	movzx	eax,[xres_var]
	cmp	dword .x2,eax  ;SIZE_X
	jl	@f
	mov	dword .x2,eax  ;SIZE_X
      @@:
	movzx	eax,[xres_var]	;SIZE_X       ;calc memory begin in buffers
	mul	.y
	add	eax,.x1
	shl	eax,2
	mov	esi,eax
	add	esi,.z_buff	  ; z-buffer filled with dd variables
	add	edi,eax


	mov	ecx,.x2
	sub	ecx,.x1

	mov	  .czbuff,esi
	mov	  .c_scr,edi


	movdqu	xmm7,.cey
	movdqu	xmm6,.dey
	movq	xmm5,.cty
	movq	xmm4,.dty
	cld

     .draw:
    ; if TEX = SHIFTING   ;bump drawing only in shifting mode
	mov	esi,.czbuff	 ; .czbuff current address in buffer
	mov	ebx,.cz 	 ; .cz - cur z position
	cmp	ebx,dword[esi]
	jge	.skip
	movhlps xmm1,xmm7
	movlhps xmm1,xmm7
	psrld	xmm1,ROUND
	movd	eax,xmm1
	shufps	xmm1,xmm1,00111001b
      ;  psrldq  xmm1,4
	movd	esi,xmm1


	shl	eax,TEX_SHIFT
	add	esi,eax 	;-  ; esi - current bump map index
	push	esi
	mov	edi,.tsiz
	mov	ebx,esi
	dec	esi
	and	esi,edi  ;.tsiz
	add	esi,.bmap
	xor	eax,eax
	lodsb

	mov	esi,ebx
	inc	esi
	and	esi,edi  ;.tsiz
	add	esi,.bmap
	xchg	eax,edx
	xor	eax,eax
	lodsb
	sub	eax,edx
	xchg	eax,edx

	mov	esi,ebx
	push	esi
	sub	esi,.tex_x
	and	esi,edi  ;.tsiz
	add	esi,.bmap
	xor	eax,eax
	lodsb


	pop	esi
	add	esi,.tex_x
	and	esi,edi  ;.tsiz
	add	esi,.bmap
	xchg	ebx,eax
	xor	eax,eax
	lodsb
	sub	eax,ebx


     ;	eax - horizontal sub	modificated x coord
     ;	edx - vertical	 sub	modificated y coord
     ;	xmm1 - copy of cur env coords
	movhlps xmm2,xmm1
	shufps	xmm1,xmm1,00111001b
	movd	ebx,xmm1
	add	edx,ebx
	movd	ebx,xmm2
	add	eax,ebx


	shl	edx,TEX_SHIFT	; zaburzenie w emapie = zaburzenie w teksturze
	add	edx,eax 	; proponuje nie stawiac czarnego pixela tylko
	and	edx,edi  ;.tsiz  ;TEXTURE_SIZE
	mov	esi,edx
	shl	esi,2
	add	esi,.emap
	lodsd

	movaps	xmm1,xmm5
	movd	edx,xmm1
	shufps	xmm1,xmm1,00111001b
	movd	edi,xmm1


  ;	 shl	  edx,TEX_SHIFT
  ;	 add	  edi,edx
  ;	 and	  edi,.tsiz  ;TEXTURE_SIZE
  ;	 mov	  esi,edi
	pop	 esi	   ; bump = tex coords
	shl	 esi,2
	add	 esi,.tex_map

	movd	   xmm0,eax
	pxor	   xmm1,xmm1
	punpcklbw  xmm0,xmm1
	movd	   xmm2,[esi]
	punpcklbw  xmm2,xmm1
	pmullw	   xmm0,xmm2
	psrlw	   xmm0,8
	packuswb   xmm0,xmm1
	movd	   eax,xmm0
	mov	   edi,.c_scr
	stosd

	mov	 eax,.cz
	mov	 edi,.czbuff
	stosd

      .skip:
	add	dword .czbuff,4
	add	dword .c_scr,4
      ;  add	 dword .tex_map,4

	paddd	xmm7,xmm6
	paddd	xmm5,xmm4


	mov	eax,.dz
	add	.cz,eax
      ;  loop	 .draw
	dec	ecx
	jnz	.draw

  .bl_end:
	mov	esp,ebp
ret 24
