x3d equ 0
y3d equ 2
z3d equ 4
vec_x equ 0
vec_y equ 4
vec_z equ 8
; 3d point - triple integer word coordinate
; vector   - triple float dword coordinate
;----------------------in: --------------------------------
;------------------------ esi - pointer to 1st 3d point ---
;------------------------ edi - pointer to 2nd 3d point ---
;------------------------ ebx - pointer to result vector --
;---------------------- out : none ------------------------

make_vector_r:
	movups xmm0,[edi]
	movups xmm1,[esi]
	subps  xmm0,xmm1
	movhlps xmm1,xmm0
	movlps [ebx],xmm0
	movss  [ebx+8],xmm1
ret


;double determinant =	 +A(0,0)*(A(1,1)*A(2,2)-A(2,1)*A(1,2))
;			 -A(0,1)*(A(1,0)*A(2,2)-A(1,2)*A(2,0))
;			 +A(0,2)*(A(1,0)*A(2,1)-A(1,1)*A(2,0));
;ouble invdet = 1/determinant;
;result(0,0) =	(A(1,1)*A(2,2)-A(2,1)*A(1,2))*invdet;
;result(1,0) = -(A(0,1)*A(2,2)-A(0,2)*A(2,1))*invdet;
;result(2,0) =	(A(0,1)*A(1,2)-A(0,2)*A(1,1))*invdet;
;result(0,1) = -(A(1,0)*A(2,2)-A(1,2)*A(2,0))*invdet;
;result(1,1) =	(A(0,0)*A(2,2)-A(0,2)*A(2,0))*invdet;
;result(2,1) = -(A(0,0)*A(1,2)-A(1,0)*A(0,2))*invdet;
;result(0,2) =	(A(1,0)*A(2,1)-A(2,0)*A(1,1))*invdet;
;result(1,2) = -(A(0,0)*A(2,1)-A(2,0)*A(0,1))*invdet;
;result(2,2) =	(A(0,0)*A(1,1)-A(1,0)*A(0,1))*invdet;



 ;  movups xmm0,[esi]
 ;  movups xmm1,[esi+12]
 ;  movups xmm2,[esi+24]
 ;  movaps xmm3,xmm0
 ;  movaps xmm4,xmm1
   
 ;  punpckldq xmm3,xmm1    ; xmm3	+16  +4   +12  +0
 ;  movlps xmm3,xmm0
 ;  movhps xmm3,xmm1	   ; m3 -     1,0  0,1 1,0 0,0

;  movups  xmm0,[esi]
;  movups  xmm1,[esi+12]
;  movups  xmm2,[esi+20]
;  movaps  xmm6,xmm2
;  shufps  xmm3,xmm0,11111001b	  ; +8 +4
;  shufps  xmm5,xmm2,11110111b	  ;
;  shufps  xmm4,xmm1,1111
   


reverse_mx_3x3:
; esi - source matrix
; edi - desired reversed matrix

  push	ebp
  mov	ebp,esp
  sub	esp,4
  .det	equ  ebp-4

  fninit
  fld  dword[esi]
  fmul dword[esi+16]
  fmul dword[esi+32]
  fld  dword[esi+12]
  fmul dword[esi+28]
  fmul dword[esi+8]
  faddp
  fld  dword[esi+24]
  fmul dword[esi+4]
  fmul dword[esi+20]
  faddp
  fld  dword[esi]
  fmul dword[esi+28]
  fmul dword[esi+20]
  fchs
  faddp
  fld  dword[esi+24]
  fmul dword[esi+16]
  fmul dword[esi+8]
  fchs
  faddp
  fld  dword[esi+12]
  fmul dword[esi+4]
  fmul dword[esi+32]
  fchs
  faddp
  fstp dword[.det]
  cmp  dword[.det],0
  jne  @f
  int3
 @@:
  fld1
  fdiv dword[.det]
  fstp dword[.det]

  fld  dword[esi+16]
  fmul dword[esi+32]
  fld  dword[esi+20]
  fmul dword[esi+28]
  fchs
  faddp
  fmul dword[.det]
  fstp dword[edi]

  fld  dword[esi+8]
  fmul dword[esi+28]
  fld  dword[esi+4]
  fmul dword[esi+32]
  fchs
  faddp
  fmul dword[.det]
  fstp dword[edi+4]

  fld  dword[esi+4]
  fmul dword[esi+20]
  fld  dword[esi+8]
  fmul dword[esi+16]
  fchs
  faddp
  fmul dword[.det]
  fstp dword[edi+8]

  fld  dword[esi+20]
  fmul dword[esi+24]
  fld  dword[esi+12]
  fmul dword[esi+32]
  fchs
  faddp
  fmul dword[.det]
  fstp dword[edi+12]

  fld  dword[esi]
  fmul dword[esi+32]
  fld  dword[esi+8]
  fmul dword[esi+24]
  fchs
  faddp
  fmul dword[.det]
  fstp dword[edi+16]

  fld  dword[esi+8]
  fmul dword[esi+12]
  fld  dword[esi]
  fmul dword[esi+20]
  fchs
  faddp
  fmul dword[.det]
  fstp dword[edi+20]

  fld  dword[esi+12]
  fmul dword[esi+28]
  fld  dword[esi+16]
  fmul dword[esi+24]
  fchs
  faddp
  fmul dword[.det]
  fstp dword[edi+24]

  fld  dword[esi+4]
  fmul dword[esi+24]
  fld  dword[esi]
  fmul dword[esi+28]
  fchs
  faddp
  fmul dword[.det]
  fstp dword[edi+28]

  fld  dword[esi]
  fmul dword[esi+16]
  fld  dword[esi+4]
  fmul dword[esi+12]
  fchs
  faddp
  fmul dword[.det]
  fstp dword[edi+32]


  mov  esp,ebp
  pop  ebp
ret





;---------------------- in: -------------------------------
;--------------------------- esi - pointer to 1st vector --
;--------------------------- edi - pointer to 2nd vector --
;--------------------------- ebx - pointer to result vector
;---------------------- out : none
cross_product:
      movups  xmm0,[esi]
      movups  xmm1,[esi]
      movups  xmm2,[edi]
      movups  xmm3,[edi]
      shufps  xmm0,xmm0,00001001b
      shufps  xmm1,xmm1,00010010b
      shufps  xmm2,xmm2,00010010b
      shufps  xmm3,xmm3,00001001b
      mulps   xmm0,xmm2
      mulps   xmm1,xmm3
      subps   xmm0,xmm1
      movhlps xmm1,xmm0
      movlps  [ebx],xmm0
      movss   [ebx+8],xmm1


ret
cross_aligned:
      movaps  xmm0,[esi]
      movaps  xmm2,[edi]
      movaps  xmm1,xmm0
      movaps  xmm3,xmm2
      shufps  xmm0,xmm0,00001001b
      shufps  xmm1,xmm1,00010010b
      shufps  xmm2,xmm2,00010010b
      shufps  xmm3,xmm3,00001001b
      mulps   xmm0,xmm2
      mulps   xmm1,xmm3
      subps   xmm0,xmm1
      movaps  [ebx],xmm0
ret
cross_reg:
; src1 - xmm0
; src2 - xmm1
; out:
; cross - xmm0

      movaps  xmm2,xmm0
      movaps  xmm3,xmm1
      shufps  xmm0,xmm0,00001001b
      shufps  xmm2,xmm2,00010010b
      shufps  xmm1,xmm1,00010010b
      shufps  xmm3,xmm3,00001001b
      mulps   xmm0,xmm1
      mulps   xmm2,xmm3
      subps   xmm0,xmm2
ret
;----------------------- in: ------------------------------
;---------------------------- edi - pointer to vector -----
;----------------------- out : none
normalize_vector:
  movups  xmm0,[edi]
  andps   xmm0,[zero_hgst]
  movaps  xmm1,xmm0
  mulps   xmm0,xmm0
  haddps  xmm0,xmm0
  haddps  xmm0,xmm0
  rsqrtps xmm0,xmm0
  mulps   xmm1,xmm0
  movlps  [edi],xmm1
  movhlps xmm1,xmm1
  movss   [edi+8],xmm1
ret
;------------------in: -------------------------
;------------------ esi - pointer to 1st vector
;------------------ edi - pointer to 2nd vector
;------------------out:
;------------------ xmm0 - broadcasted dot-product
dot_product1:

	movups	xmm0,[esi]
	movups	xmm1,[edi]
	andps	xmm0,[zero_hgst]
	mulps	xmm0,xmm1
	haddps	xmm0,xmm0
	haddps	xmm0,xmm0

ret


make_matrixX:
; in:  eax, ebx, edx  - rot params;  edi - ptr to  desired matrix

   push   ebp
   mov	  ebp,esp

  .cosxx   equ dword[ebp-20]
  .sinxx   equ [ebp-24]
  .cosyx   equ dword[ebp-28]
  .sinyx   equ [ebp-32]
  .coszx   equ dword[ebp-36]
  .sinzx   equ [ebp-40]


    sub 	esp,40
    mov 	ecx,sin_cos_tab256
    and 	edx,0xff
    shl 	edx,3
    add 	edx,ecx  ;sin_cos_tab256
    movlps	xmm0,[edx]
    movlps	.sinxx,xmm0

    and 	ebx,0xff
    shl 	ebx,3
    add 	ebx,ecx ;sin_cos_tab256
    movhps	xmm0,[ebx]
    and 	eax,0xff
    shl 	eax,3
    add 	eax,ecx  ;sin_cos_tab256
    movlps	xmm0,[eax]
    movups	.sinzx,xmm0
    push	dword .sinxx
    push	.cosxx
    push	dword .sinyx
    push	.cosyx
    push	dword  .sinzx
    push	.coszx

    call	make_rotation_matrix
   ; edi -  desired matrix

    mov 	esp,ebp
    pop 	ebp

ret

;------
; stack sinus, cosinus variables, edi offset to 3x3 matrix
make_rotation_matrix:
   .sinx   equ [ebp+8]
   .cosx   equ dword[ebp+12]
   .siny   equ [ebp+16]
   .cosy   equ dword[ebp+20]
   .sinz   equ dword[ebp+24]
   .cosz   equ dword[ebp+28]

     push      ebp
     mov       ebp,esp
;     sub	esp,24

if 0
     movups    xmm0,.siny
     movaps    xmm1,xmm0
     movhlps   xmm2,xmm0
     movhps    xmm0,.sinx
     shufps    xmm0,xmm0,10100101b
     movaps    xmm3,xmm0
     shufps    xmm1,xmm1,11111011b  ; +0    +4	 +12   +16
		 ;	  xmm0 ->   ; cosy, cosy, sinx, sinx
		 ;	  xmm1	    ; cosz, sinz, cosz, sinz


     shufps    xmm2,xmm2,10100100b
		;	  xmm2	->  ;		  ,siny, siny
;     muaps	xmm1,xmm0
     movlps    [edi],xmm1
     mulps     xmm1,xmm2
     movhps    [edi+12],xmm1
     int3
end if

     fninit

     fld       .cosy
     fmul      .cosz
     fstp      dword[edi]

     fld       dword .sinx
     fmul      .cosz
     fmul      dword .siny
     fld       .cosx
     fmul      .sinz
     fchs
     faddp
 ;    fadd	dword[edi+12]
     fstp      dword[edi+12]

     fld       .cosx
     fmul      .cosz
     fmul      dword .siny
     fld       dword .sinx
     fmul      .sinz
     faddp
     fstp      dword[edi+24]

     fld       .cosy
     fmul      .sinz
     fstp      dword[edi+4]

     fld       dword .sinx
     fmul      .sinz
     fmul      dword .siny
     fld       .cosx
     fmul      .cosz
     faddp
;     fadd	dword[edi+16]
     fstp      dword[edi+16]

     fld       .cosx
     fmul      dword .siny
     fmul      .sinz
     fld       dword .sinx
     fchs
     fmul      .cosz
     faddp
     fstp      dword[edi+28]

     fld       dword .siny
     fchs
     fstp      dword[edi+8]

     fld       .cosy
     fmul      dword .sinx
     fstp      dword[edi+20]

     fld       .cosx
     fmul      .cosy
     fstp      dword[edi+32]

     mov       esp,ebp
     pop       ebp

ret 24

;---------------------
;  in:	esi - ptr to points(normals], each point(normal) coeficient as dword
;	edi - ptr to rotated points(normals)
;	ebx - ptr to 3x3 (9 dwords, 36 bytes) rotation matrix
;	ecx - number of points(normals)
rotary:
;   Copyright (C) 1999-2001  Brian Paul
;---------------------
;  in:	esi - ptr to points(normals], each point(normal) coeficient as dword
;	edi - ptr to rotated points(normals)
;	ebx - ptr to 3x3 (9 dwords, 36 bytes) rotation matrix
;	ecx - number of points(normals)

  ;  push     ebp

    movups   xmm4,[ebx]
    movups   xmm5,[ebx+12]
    movups   xmm6,[ebx+24]
  .again:
    movss    xmm0,dword[esi]
    movss    xmm1,dword[esi+4]
    movss    xmm2,dword[esi+8]
    shufps   xmm0,xmm0,0
    shufps   xmm1,xmm1,0
    shufps   xmm2,xmm2,0
    mulps    xmm0,xmm4
    mulps    xmm1,xmm5
    mulps    xmm2,xmm6
    addps    xmm0,xmm1
    addps    xmm0,xmm2
    movlps   [edi],xmm0
    movhlps  xmm0,xmm0
    movss    [edi+8],xmm0
    add      esi,12
    add      edi,12
    loop     .again

  ;  pop      ebp

ret





mul_matrix4x4:
;  in:	esi - ptr to points
;	edi - ptr to multiplied points
;	ebx - ptr to 4x4 (16 dwords, 64 bytes) matrix
;	ecx - number of points (vertices)
    push	 ebp

    movups   xmm4,[ebx]
    movups   xmm5,[ebx+16]
    movups   xmm6,[ebx+32]
    movups   xmm7,[ebx+48]

  .aagain1:
    movss    xmm0,dword[esi]
    movss    xmm1,dword[esi+4]
    movss    xmm2,dword[esi+8]
    shufps   xmm0,xmm0,0
    shufps   xmm1,xmm1,0
    shufps   xmm2,xmm2,0
    mulps    xmm0,xmm4
    mulps    xmm1,xmm5
    mulps    xmm2,xmm6

    addps    xmm0,xmm1
    addps    xmm0,xmm2
    addps    xmm0,xmm7

    movlps   [edi],xmm0
    movhlps  xmm0,xmm0
    movss    [edi+8],xmm0

    add      esi,12
    add      edi,12
    loop      .aagain1

    pop       ebp

ret


;----------------------------------------------
;  esi - pointer to 3x3 matrix
;  ebx - ptr to scale
add_scale_to_matrix:
     movss   xmm3,[ebx]
     movups  xmm0,[esi]
     shufps  xmm3,xmm3,0
     movups  xmm1,[esi+16]
     movlps  xmm2,[esi+32]
     mulps   xmm0,xmm3
     mulps   xmm1,xmm3
     mulps   xmm2,xmm3
     movups  [esi],xmm0
     movups  [esi+16],xmm1
     movlps  [esi+32],xmm2
ret

