

ROUND2 equ 10




flat_triangle_z_float:

;  ----------------in - eax - x1 shl 16 + y1 ----------------------
;  -------------------- ebx - x2 shl 16 + y2 ----------------------
;  -------------------- ecx - x3 shl 16 + y3 ----------------------
;  -------------------- edx - color 0x00RRGGBB --------------------
;  -------------------- esi - pointer to Z-buffer -----------------
;  -------------------- edi - pointer to screen buffer-------------
;			xmm0 - z params
;			xmm5 - ymax, ymin  as words
;  -------------------- stack : other - xres
;  -------------------- Z-buffer : each delta z variable as dword
;  -------------------- float , coords as dword float


.xxres	 equ dword [ebp+8]


.x1	equ [ebp-2]
.y1	equ [ebp-4]
.x2	equ [ebp-6]
.y2	equ [ebp-8]
.x3	equ [ebp-10]
.y3	equ [ebp-12]
.hlp1	equ [ebp-14]


.dx12	equ dword[ebp-20]
.dx13	equ dword[ebp-24]
.dx23	equ [ebp-28]
.dz12	equ dword[ebp-32]
.dz13	equ [ebp-36]
.dz23	equ [ebp-40]
.zz2	equ [ebp-44]
.zz1	equ [ebp-48]
.z3	equ [ebp-56]
.z2	equ [ebp-60]
.z1	equ [ebp-64]
.ymin	equ [ebp-68]
.ymax	equ [ebp-70]


	push	ebp
	mov	ebp,esp

      .sort2:
	cmp	ax,bx
	jle	.sort1
	xchg	eax,ebx
	shufps	xmm0,xmm0,11100001b
      .sort1:
	cmp	bx,cx
	jle	.sort3
	xchg	ebx,ecx
	shufps	xmm0,xmm0,11011000b
	jmp	.sort2
      .sort3:
	movd	xmm7,edx
	push	eax ebx ecx

	; store triangle coordinates in user friendly variables


	sub	 esp,70
	movd	 .ymax,xmm5
	movdqu	 .z1,xmm0
	movdqa	 xmm1,xmm0


	xorps	  xmm2,xmm2
	xorps	  xmm4,xmm4
	movups	  xmm0,.y3
	movups	  xmm3,.hlp1  ;x_res
	psrld	  xmm0,16   ; cut
	psrld	  xmm3,16
	pcmpgtw   xmm4,xmm0
	pcmpgtw   xmm2,xmm3
	pslldq	  xmm4,2
	pslldq	  xmm2,2
	por	  xmm0,xmm4
	por	  xmm3,xmm3

	movaps	  xmm2,xmm0
	movaps	  xmm4,xmm3

	shufps	  xmm0,xmm0,11101001b
	shufps	  xmm2,xmm2,11010000b
	psubd	  xmm2,xmm0
	cvtdq2ps  xmm2,xmm2


	shufps	  xmm3,xmm3,11101001b
	shufps	  xmm4,xmm4,11010000b
	psubd	  xmm4,xmm3
	cvtdq2ps  xmm4,xmm4

	mov	  eax,1 shl ROUND2
	cvtsi2ss  xmm5,eax
	shufps	  xmm5,xmm5,0
	mulps	  xmm2,xmm5

	rcpps	  xmm4,xmm4
	mulps	  xmm2,xmm4


	cvtps2dq  xmm2,xmm2

	movaps	  xmm0,xmm1
	shufps	  xmm0,xmm0,11011010b
	shufps	  xmm1,xmm1,11000001b
	subps	  xmm0,xmm1
	mulps	  xmm0,xmm4
	movups	  .dz23,xmm0

	movups	  .dx23,xmm2


	movss	  xmm0,.z1
	shufps	  xmm0,xmm0,0
	movlps	  .zz1,xmm0

	movsx	 eax,word .x1
	shl	 eax,ROUND2    ; eax - cur x1
	mov	 ebx,eax       ; ebx - cur x2

  ;	 mov	  edx,.xxres

	movzx	 ecx,word .y1
	cmp	 cx,.y2
	jge	 .loop1_end
     .loop1:

	pushad
	mov	 edx,.xxres
	movd	xmm5,.ymax
	sar	ebx,ROUND2
	sar	eax,ROUND2

	call	flat_line

	popad

	add	eax,.dx13
	add	ebx,.dx12

	movlps	xmm0,.zz1
	movlps	xmm2,.dz13
	addps	xmm0,xmm2
	movlps	.zz1,xmm0  ;

	inc	ecx
	cmp	cx,.y2
	jl	.loop1

    .loop1_end:

	mov	edx,.z2
	mov	.zz2,edx
	movlps	xmm0,.zz1

	movsx	ebx,word .x2
	shl	ebx,ROUND2
	mov	edx,.xxres
	mov	cx,.y2
	cmp	cx,.y3
	jge	.loop2_end
     .loop2:
	pushad
	movd	xmm5,.ymax
	sar	ebx,ROUND2
	sar	eax,ROUND2

	call	flat_line

	popad

	add	eax,.dx13
	add	ebx,.dx23


	movlps	xmm0,.zz1
	movlps	xmm1,.dz23
	shufps	xmm1,xmm1,11110001b
	addps	xmm0,xmm1
	movlps	.zz1,xmm0

	inc	ecx
	cmp	cx,.y3
	jl	.loop2
     .loop2_end:

	mov    esp,ebp
	pop    ebp

ret 4

flat_line:
;----------------------------------------------------
;-------------in xmm0 - lo -> hi z1, z2
;--------------- eax - x1 ---------------------------
;--------------- ebx - x2 ---------------------------
;--------------- ecx - y-----------------------------
;--------------- edx - x_res ------------------------
;--------------- esi - pointer to z-buffer ----------
;--------------- edi - screen buf
;--------------- xmm7 - col -------------------------
;		 xmm5 - ymax, ymin as words ---------

.x_res	equ [ebp-4]
.x1	equ [ebp-8]
.x2	equ [ebp-12]
.z2	equ [ebp-16]
.z1	equ [ebp-20]


     push	ebp
     mov	ebp,esp
     push	edx
     movd	edx,xmm5

     cmp	cx,dx
     jg 	.l_quit

     ror	edx,16
     cmp	cx,dx
     jle	.l_quit

     movzx	ecx,cx
     cmp	eax,ebx
     je 	.l_quit
     jl 	.l_ok

     xchg	eax,ebx
     shufps	xmm0,xmm0,11100001b
   .l_ok:


     push	eax
     push	ebx
     sub	esp,30

     mov	edx,.x_res
     cmp	dword .x1,edx
     jge	.l_quit
     cmp	dword .x2,0
     jle	.l_quit

     movlps	.z1,xmm0
     sub	ebx,eax
     movss	xmm6,.z2
     cvtsi2ss	xmm1,ebx
     rcpss	xmm1,xmm1
     subss	xmm6,xmm0  ;.z1
     mulss	xmm6,xmm1

     cmp	eax,0	; clipping
     jge	@f
     mov	eax,.x1
     neg	eax
     cvtsi2ss	xmm2,eax
     mulss	xmm2,xmm6 ;.dz
     addss	xmm2,xmm0 ;.z1
     movss	.z1,xmm2
     mov	dword .x1,0
  @@:

     mov	edx,.x_res
     cmp	.x2,edx
     jl 	@f
     mov	.x2,edx
   @@:

     mov	eax,ecx
     mul	edx
     add	eax,.x1

     shl	eax,2
     add	esi,eax
     add	edi,eax

     mov	ecx,.x2
     sub	ecx,.x1
     movss	xmm2,.z1   ; cz
     mov	ebx,4
     movd	eax,xmm7
   .ccalc:
     movss     xmm1,xmm2
     cmpltss   xmm1,dword[esi]
     movd      edx,xmm1
     or        edx,edx
     jz        @f
     mov       [edi],eax
     movss     dword[esi],xmm2
    @@:
     add       esi,ebx
     add       edi,ebx
     addss     xmm2,xmm6
     loop      .ccalc


  .l_quit:
     mov       esp,ebp
     pop       ebp
ret

