; Glass like rendering triangle by Maciej Guba.
; http://macgub.co.pl, macgub@macgub.co.pl

ROUND2 equ 10

;----procedure render glass like triangle with z coord --
;----interpolation ( Catmull alghoritm )-----------------
;----I normalize normal vector in every pixel -----------

; first stage - look at 'glass_tex_tri' proc

glass_line:

     shufps  xmm3,xmm5,00100010b
     shufps  xmm3,xmm3,11101000b
; in:
;    xmm0 - normal vector 1
;    xmm1 - normal vect 2
;    xmm3 - lo -> hi z1, z2 coords as dwords floats
;    xmm2 - lo -> hi y_min, y_max, x_min, x_max
;	    as dword integers
;    eax - x1
;    ebx - x2
;    ecx - y
;    edx - stencil buff ptr
;    edi - screen buffer
;    esi - z buffer ===> not needed in glass rendering

   push  ebp
   mov	 ebp,esp
   sub	 esp,150
   and	 ebp,-16

 .dz	  equ [ebp-16]
 .n2	  equ [ebp-32]
 .the_one equ [ebp-48]
 .lx1	  equ [ebp-52]
 .lx2	  equ [ebp-56]
 .z2	  equ [ebp-60]
 .z1	  equ [ebp-64]
; .screen equ [ebp-68]
; .zbuff  equ [ebp-72]
 .x_max  equ [ebp-74]
 .x_min  equ [ebp-76]
 .y_max  equ [ebp-78]
 .y_min  equ [ebp-80]
 .dn	 equ [ebp-96]
 .y	 equ [ebp-100]
 .lae	 equ [ebp-104]
 .la	 equ [ebp-108]

	mov	 .y,ecx
	packssdw xmm2,xmm2
	movq	 .y_min,xmm2
	cmp	 cx,.y_min
	jl	 .end_rp_line
	cmp	 cx,.y_max
	jge	 .end_rp_line	       ;

	cmp	eax,ebx
	je	.end_rp_line
	jl	@f
	xchg	eax,ebx
	movaps	xmm7,xmm0
	movaps	xmm0,xmm1
	movaps	xmm1,xmm7
	shufps	xmm3,xmm3,11100001b
   @@:

	cmp	ax,.x_max
	jge	.end_rp_line
	cmp	bx,.x_min
	jle	.end_rp_line
	movaps	.n1,xmm0
	movaps	.n2,xmm1
	mov	.lx1,eax
	mov	.lx2,ebx
	movlps	.z1,xmm3
	sub	ebx,eax
	cvtsi2ss xmm7,ebx
	rcpss	xmm7,xmm7
	shufps	xmm7,xmm7,0
	subps	xmm1,xmm0
	mulps	xmm1,xmm7
	andps	xmm1,[zero_hgst_dd]  ; calc absolute z coeficient value
	movaps	.dn,xmm1
	psrldq	xmm3,4
	subss	xmm3,.z1
	mulps	xmm3,xmm7
	movaps	.dz,xmm3

	mov	 ebx,.lx1
	cmp	 bx,.x_min     ; clipping on function4
	jge	 @f
	movzx	 eax,word .x_min
	sub	 eax,ebx
	cvtsi2ss xmm7,eax
	shufps	 xmm7,xmm7,0
	mulss	 xmm3,xmm7
	mulps	 xmm1,xmm7
	addss	 xmm3,.z1
	addps	 xmm1,xmm0  ;.n1
	movsx	 eax,word .x_min
	movss	 .z1,xmm3
	movaps	 xmm0,xmm1
	mov	 dword .lx1,eax

      @@:
	movzx	eax,word .x_max
	cmp	.lx2,eax
	jl	@f
	mov	.lx2,eax
      @@:
	movzx	eax,word[xres_var]
	mul	dword .y


	add	eax,.lx1
	shl	eax,2
	add	edi,eax
	add	esi,eax

	mov	ecx,.lx2
	sub	ecx,.lx1

	andps	xmm0,[zero_hgst_dd]  ; calc absolute z coeficient value
	movss	xmm2,.z1
	movaps	xmm3,[mask_255f]
	mov	ebx,4
	mov	dword .the_one,1.0
	mov	dword .lae,lights_aligned_end
	mov	dword .la,lights_aligned


   .ddraw:
	movaps	 xmm7,xmm0
	mulps	 xmm7,xmm7 ; normalize
	haddps	 xmm7,xmm7
	haddps	 xmm7,xmm7
	rsqrtps  xmm7,xmm7
	mulps	 xmm7,xmm0
;	 andps	  xmm7,[abs_z_coof]  ; calc absolute z coeficient value
	movaps	 xmm4,xmm7

	mov	 edx,.la  ;lights_aligned
	xorps	 xmm1,xmm1

      .again_col:
;	 int3
	movaps	  xmm7,xmm4
	mulps	  xmm7,[edx]
	haddps	  xmm7,xmm7
	haddps	  xmm7,xmm7
	; stencil
	movaps	  xmm5,xmm2
	movaps	  xmm6,xmm2
	addps	  xmm5,.the_one
	subps	  xmm6,.the_one

	cmpnltss  xmm5,dword[esi]
	cmpnltss  xmm6,dword[esi]
;	 movss	   xmm6,[esi]
	xorps	  xmm5,xmm6
	xorps	  xmm6,xmm6
	movd	  eax,xmm5
	or	  eax,eax
	jz	  .no_reflective
     @@:
	movaps	  xmm6,xmm7
	mulps	  xmm6,xmm6
	mulps	  xmm6,xmm6
	mulps	  xmm6,xmm6
	mulps	  xmm6,[edx+48]
	movaps	  xmm7,xmm6
	jmp	  .on_rf
      .no_reflective:
	mulps	  xmm7,[edx+16]
	addps	  xmm7,xmm6
	addps	  xmm7,[edx+32]
       .on_rf:
	minps	  xmm7,xmm3


	maxps	  xmm1,xmm7
	add	  edx,64	  ; size of one light in aligned list
	cmp	  edx,dword .lae  ; lights_aligned_end
	jl	  .again_col

	cvtps2dq  xmm1,xmm1
	movd	  xmm6,[edi]
	packssdw  xmm1,xmm1
	packuswb  xmm1,xmm1
	paddusb   xmm1,xmm6
	movd	  [edi],xmm1

     .skip:
	add	 edi,ebx
	add	 esi,ebx   ; stencil_buff
	addps	 xmm0,.dn
	addps	 xmm2,.dz
      ;  loop	  .ddraw
	dec	 ecx
	jnz	 .ddraw

  .end_rp_line:
	add	 esp,150
	pop	 ebp

ret
