; Bilinear filtering, real Phongs shading and glass like parallel.
; Thanks to authors of 3dica tutorial.
; Implemented in FASM by Maciej Guba.
; http://macgub.co.pl

ROUND2 equ 10

glass_tex_tri:
;----Procedure render Phongs shaded triangle with z coord
;----interpolation ( Catmull alghoritm ), each pixel is -
;----covered by texture using bilinear filtering.--------
;----I normalize normal vector in every pixel -----------
;------------------in - eax - x1 shl 16 + y1 ------------
;---------------------- ebx - x2 shl 16 + y2 ------------
;---------------------- ecx - x3 shl 16 + y3 ------------
;---------------------- esi - pointer to stencil buffer--
;----------------------   filled with dd float variables-
;---------------------- edi  - pointer to screen buffer---
;---------------------- edx  - pointer to texture---------
;---------------------- xmm0 - 1st normal vector --------
;---------------------- xmm1 - 2cond normal vector ------
;---------------------- xmm2 - 3rd normal vector --------
;---------------------- xmm3 - tex coords tx3, ty3 as
;----------------------------- float dwords -------
;---------------------- xmm4 - lo -> hi z1, z2, z3 coords
;----------------------  as dwords floats ---------------
;---------------------- xmm5 - lo -> hi y_min, y_max, ---
;----------------------  x_min, x_max as dword integers 
;---------------------- xmm6 - tex 4 dwords lo -> hi ----
;----------------------  tx1, ty1, tx2, ty2 as dword ----
;----------------------  floats--------------------------
;---------------------- xmm7 - line_ptr
;---------------------- stack - no parameters -----------
;--------------------------------------------------------
;----------------- procedure don't save registers !! ----




  push  ebp
  mov   ebp,esp
  sub   esp,360
  and   ebp,0xfffffff0
  sub   ebp,128

  .dn12 equ [ebp+112]
  .1_nv equ [ebp+96]
  .2_nv equ [ebp+80]
  .3_nv equ [ebp+64]

  .z3   equ [ebp+56]
  .z2   equ [ebp+52]
  .z1   equ [ebp+48]

  .x1   equ [ebp+46]
  .y1   equ [ebp+44]
  .x2   equ [ebp+42]
  .y2   equ [ebp+40]
  .x3   equ [ebp+38]
  .y3   equ [ebp+36]
  .hlp  equ [ebp+34]
  .Zbuf equ [ebp+32]

  .x_max equ  [ebp+28]
  .x_min equ  [ebp+24]
  .y_max equ  [ebp+20]
  .y_min equ  [ebp+16]
  .l_ptr  equ dword [ebp+128]
  .dx12   equ [ebp+8]
  .dx13   equ [ebp+4]
  .dx23   equ [ebp]


  .dn13   equ [ebp-16]
  .dn23   equ [ebp-32]
  .cnv1   equ [ebp-48]  ; cur normal vectors
  .cnv2   equ [ebp-64]

  .dz13   equ [ebp-72]
  .dty13  equ [ebp-76]
  .dtx13  equ [ebp-80]

  .dz12   equ [ebp-88]
  .dty12  equ [ebp-92]
  .dtx12  equ [ebp-96]

  .dz23   equ [ebp-104]
  .dty23  equ [ebp-108]
  .dtx23  equ [ebp-112]

  .cz1    equ [ebp-120]
  .cty1   equ [ebp-124]
  .ctx1   equ [ebp-128]

 ; .cz2    equ [edx-]
 ; .cty2   equ [edx-12]
 ; .ctx2   equ [edx--128]

  .cz2    equ [ebp-136]
  .cty2   equ [ebp-140]
  .ctx2   equ [ebp-144]




  .x_res  equ [ebp-148]
  .ty3    equ [ebp-152]
  .tx3    equ [ebp-156]
  .ty2    equ [ebp-160]
  .tx2    equ [ebp-164]
  .ty1    equ [ebp-168]
  .tx1    equ [ebp-172]

  .tx_ptr equ [ebp-176]
;
;  .x_res  equ [edx-24]
;  .ty3    equ [ebp-28]
;  .tx3    equ [ebp-32]
;  .ty2    equ [edx-32]
;  .tx2    equ [ebp-164]
;  .ty1    equ [ebp-168]
;  .tx1    equ [ebp-172]

  .tx_ptr equ [ebp-176]

       movd    .l_ptr,xmm7
 .sort3:                  ; sort triangle coordinates...
       cmp     ax,bx
       jle     .sort1
       xchg    eax,ebx
       shufps  xmm4,xmm4,11100001b
       shufps  xmm6,xmm6,01001110b
       movaps  xmm7,xmm0
       movaps  xmm0,xmm1
       movaps  xmm1,xmm7


 .sort1:
       cmp      bx,cx
       jle      .sort2
       xchg     ebx,ecx
       shufps   xmm4,xmm4,11011000b
       movaps   xmm7,xmm6
       movlhps  xmm6,xmm3
       movhlps  xmm3,xmm7

       movaps   xmm7,xmm1
       movaps   xmm1,xmm2
       movaps   xmm2,xmm7

       jmp .sort3

 .sort2:
   movups  .tx1,xmm6
   movlps  .tx3,xmm3
   movaps  .z1,xmm4
   mov     .y1,eax
   mov     .y2,ebx
   mov     .y3,ecx
   movzx    ebx,[xres_var]
   mov     .x_res,ebx
   movdqa  .y_min,xmm5
if 0                            ; check if at last only fragment
   packssdw xmm5,xmm5       ; of triangle is in visable area
   pshuflw  xmm5,xmm5,11011000b
   movdqu   xmm7,.y3
   movdqa   xmm6,xmm5
   pshufd   xmm5,xmm5,0  ; xmm5 lo-hi -> broadcasted y_min, x_min
   pshufd   xmm6,xmm6,01010101b ;xmm6 -> brd y_max x_max
   movdqa   xmm4,xmm7
   pcmpgtw  xmm7,xmm5
   pcmpgtw  xmm4,xmm6
   pxor     xmm7,xmm4
   pmovmskb eax,xmm7
   and      eax,0x00aaaaaa
   or       eax,eax
   jz       .rpt_loop2_end
end if

   movaps   .1_nv,xmm0
   movaps   .2_nv,xmm1
   movaps   .3_nv,xmm2

   mov      .tx_ptr,edx

   movdqu   xmm1,.hlp
   movdqu   xmm3,.y3

   pxor     xmm0,xmm0
   pxor     xmm2,xmm2

   psrld    xmm1,16
   psrld    xmm3,16
   pcmpgtw  xmm0,xmm1
   pcmpgtw  xmm2,xmm3
   pslld    xmm0,16
   pslld    xmm2,16
   por      xmm1,xmm0
   por      xmm3,xmm2

   cvtdq2ps xmm1,xmm1
   cvtdq2ps xmm3,xmm3
   mov      eax,1 shl ROUND2
   movaps   xmm4,xmm3
   cvtsi2ss xmm5,eax

   movaps   xmm4,xmm3
   movaps   xmm2,xmm1
   shufps   xmm5,xmm5,0
   shufps   xmm2,xmm2,11000001b
   shufps   xmm3,xmm3,11000001b
   shufps   xmm1,xmm1,11011010b
   shufps   xmm4,xmm4,11011010b
   subps    xmm2,xmm1
   subps    xmm3,xmm4
   mulps    xmm3,xmm5

   rcpps    xmm2,xmm2
   mulps    xmm3,xmm2

   cvtps2dq xmm3,xmm3

   movaps   xmm6,xmm2
   pshufd   xmm3,xmm3,11000110b
   movaps   xmm7,.2_nv

   shufps   xmm6,xmm6,0

   movdqu   .dx23,xmm3

   subps    xmm7,.1_nv
   mulps    xmm7,xmm6
   movaps   .dn12,xmm7

   movlps   xmm7,.tx2
   movlps   xmm5,.tx1
   movhps   xmm7,.z2
   movhps   xmm5,.z1
   subps    xmm7,xmm5
   mulps    xmm7,xmm6
   movaps   .dtx12,xmm7


   movaps   xmm6,xmm2
   movaps   xmm7,.3_nv
   shufps   xmm6,xmm6,01010101b
   subps    xmm7,.1_nv
   mulps    xmm7,xmm6
   movaps   .dn13,xmm7

   movlps   xmm7,.tx3
   movhps   xmm7,.z3
   subps    xmm7,xmm5
   mulps    xmm7,xmm6
   movaps   .dtx13,xmm7



   movaps   xmm6,xmm2
   movaps   xmm7,.3_nv
   shufps   xmm6,xmm6,10101010b
   subps    xmm7,.2_nv
   mulps    xmm7,xmm6
   movaps   .dn23,xmm7


   movlps   xmm7,.tx3
   movlps   xmm5,.tx2
   movhps   xmm7,.z3
   movhps   xmm5,.z2
   subps    xmm7,xmm5
   mulps    xmm7,xmm6
   movaps   .dtx23,xmm7


       movsx   eax,word .x1
       shl     eax,ROUND2
       mov     ebx,eax
       mov     edx,.z1
       movlps  xmm3,.tx1

       mov     .cz1,edx
       mov     .cz2,edx
       movaps  xmm0,.1_nv
       movlps  .ctx1,xmm3
       movlps  .ctx2,xmm3
       movaps  .cnv1,xmm0
       movaps  .cnv2,xmm0
       movaps   xmm1,xmm0
       movaps   xmm5,xmm3

     ;  mov     edx,.dx13
     ;  cmp     edx,.dx12
     ;  jg      .second_cause

       movsx    ecx,word .y1
       cmp      cx,.y2
       mov      edx,.tx_ptr
       jge      .rpt_loop1_end

    .rpt_loop1:
       pushad

       movaps   xmm2,.y_min
       movups   xmm6,.x_res
       sar      ebx,ROUND2
       sar      eax,ROUND2
       call     .l_ptr  ;glass_tex_line

       popad

       movaps   xmm0,.cnv1
       movaps   xmm1,.cnv2
       movaps   xmm3,.ctx1
       movaps   xmm5,.ctx2
       addps    xmm0,.dn13
       addps    xmm1,.dn12
       addps    xmm3,.dtx13
       addps    xmm5,.dtx12
       add      eax,.dx13
       add      ebx,.dx12

       movaps   .cnv1,xmm0
       movaps   .cnv2,xmm1
       movaps   .ctx1,xmm3
       movaps   .ctx2,xmm5
       inc      ecx
       cmp      cx,.y2
       jl       .rpt_loop1
   ;    jmp  .rpt_loop2_end

   .rpt_loop1_end:
       movsx    ecx,word .y2
       cmp      cx,.y3
       jge      .rpt_loop2_end

       movsx    ebx,word .x2                    ; eax - cur x1
       shl      ebx,ROUND2                 ; ebx - cur x2
       push     dword .z2
       pop      dword .cz2
       movlps   xmm1,.tx2
       movlps   .ctx2,xmm1
       movaps   xmm1,.2_nv
       movaps   .cnv2,xmm1
       movaps   xmm0,.cnv1
       movaps   xmm3,.ctx1
       movaps   xmm5,.ctx2
     .rpt_loop2:
       pushad

       movaps   xmm2,.y_min
       sar      ebx,ROUND2
       sar      eax,ROUND2
       movups   xmm6,.x_res
       call     .l_ptr ;glass_tex_line
       popad
       movaps   xmm0,.cnv1
       movaps   xmm1,.cnv2
       movaps   xmm3,.ctx1
       movaps   xmm5,.ctx2
       addps    xmm0,.dn13
       addps    xmm1,.dn23
       addps    xmm3,.dtx13
       addps    xmm5,.dtx23

       add      eax,.dx13
       add      ebx,.dx23

       movaps   .cnv1,xmm0
       movaps   .cnv2,xmm1
       movaps   .ctx1,xmm3
       movaps   .ctx2,xmm5

       inc     ecx
       cmp      cx,.y3
       jl       .rpt_loop2

    .second_cause:  ;dx13 > dx12

    .rpt_loop2_end:

      add   esp,360
      pop   ebp

ret

glass_tex_line:
; in:
;    xmm0 - normal vector 1
;    xmm1 - normal vect 2
;    xmm3 - lo -> hi tx1, ty1, z1 coords as dwords float
;    xmm5 - lo -> hi tx2, ty2, z2 coords as dwords float
;    xmm2 - lo -> hi y_min, y_max, x_min, x_max
;           as dword integers
;    xmm4 - normalized light vector ; not now
;    eax - x1
;    ebx - x2
;    ecx - y
;    edi - screen buffer
;    esi - stencil buffer filled with dd floats
;    edx - texture pointer (handle)
;    xmm6 - lowest dword x_res as integer

   push  ebp
   mov   ebp,esp
   sub   esp,300
   and   ebp,0xfffffff0
   sub   ebp,128            ; this way adress are shorter  -
                              ; - inbeetween   ebp +/- 128
 .n1     equ [ebp+16]
 .n2     equ [ebp+32]

 .yd     equ [ebp+60]
 .xd     equ [ebp+56]
 .yf     equ [ebp+52]
 .xf     equ [ebp+48]

 .dn     equ [ebp+64]

 .texx4  equ [ebp+120]

 .screen equ [ebp+92]
 .zbuff  equ [ebp+88]
 .x_max  equ [ebp+86]
 .x_min  equ [ebp+84]
 .y_max  equ [ebp+82]
 .y_min  equ [ebp+80]

 .x_res  equ [ebp+100]
 .y      equ [ebp+104]
 .lx1    equ [ebp+108]
 .lx2    equ [ebp+112]

 .lights_ale  equ [ebp+116]

 .cnv    equ [ebp]

 .z1     equ [ebp-8]
 .ty1    equ [ebp-12]
 .tx1    equ [ebp-16]

 .z2     equ [ebp-24]
 .ty2    equ [ebp-28]
 .tx2    equ [ebp-32]

 .cz     equ [ebp-40]
 .cty    equ [ebp-44]
 .ctx    equ [ebp-48]

 .dz     equ [ebp-56]
 .dty    equ [ebp-60]
 .dtx    equ [ebp-64]

 .tex_m2    equ [ebp-80]
 .mask_255f equ [ebp-96]
 .the_one   equ [ebp-112]

 .tx_ptr    equ [ebp-116]
 .aprox     equ [ebp-120]
 .lights_al equ [ebp-124]




        mov    .y,ecx
        packssdw xmm2,xmm2
        movq   .y_min,xmm2
        cmp    cx,.y_min
        jl     .end_line
        cmp    cx,.y_max
        jge    .end_line          ;

        cmp     eax,ebx
        je      .end_line
        jl      @f
        xchg    eax,ebx
        movaps  xmm7,xmm0
        movaps  xmm0,xmm1
        movaps  xmm1,xmm7
        movaps  xmm7,xmm3
        movaps  xmm3,xmm5
        movaps  xmm5,xmm7
   @@:

        cmp     ax,.x_max
        jge     .end_line
        cmp     bx,.x_min
        jle     .end_line
        movaps  .n1,xmm0
        movaps  .n2,xmm1
        mov     .lx1,eax
        mov     .lx2,ebx
        movaps  .tx1,xmm3
        movaps  .tx2,xmm5
        movd    .x_res,xmm6
        mov     .tx_ptr,edx
        movaps  xmm7,[tex_m2]           ; shrink adresses
        movaps  .tex_m2,xmm7
        movaps  xmm7,[mask_255f]
        movaps  .mask_255f,xmm7
        movaps  xmm7,[the_one]
        movaps  .the_one,xmm7
        push    dword [aprox]
        pop     dword .aprox
        mov     dword .lights_al,lights_aligned
        mov     dword .lights_ale,lights_aligned_end
        mov     dword .texx4,TEX_X*4


        sub     ebx,eax
        cvtsi2ss xmm7,ebx
        rcpss   xmm7,xmm7
        shufps  xmm7,xmm7,0
        subps   xmm1,xmm0
        mulps   xmm1,xmm7
        movaps  .dn,xmm1
        subps   xmm5,xmm3
        mulps   xmm5,xmm7
        movaps  .dtx,xmm5



        mov      ebx,.lx1
        cmp      bx,.x_min     ; clipping on function4
        jge      @f
        movzx    eax,word .x_min
        sub      eax,ebx
        cvtsi2ss xmm7,eax
        shufps   xmm7,xmm7,0
        mulps    xmm5,xmm7
        mulps    xmm1,xmm7
        addps    xmm5,.tx1
        addps    xmm1,.n1
        movsx    eax,word .x_min
        movaps   .tx1,xmm5
        movaps   .n1,xmm1
        mov      dword .lx1,eax

      @@:
        movzx   eax,word .x_max
        cmp     .lx2,eax
        jl      @f
        mov     .lx2,eax
      @@:
        mov     eax,.x_res
        mul     dword .y
        add     eax,.lx1
        shl     eax,2
        add     edi,eax
        add     esi,eax

        mov     ecx,.lx2
        sub     ecx,.lx1
        movaps  xmm0,.n1
        movaps  xmm2,.tx1
      ;  xorps   xmm1,xmm1

   .ddraw:
        xorps    xmm5,xmm5
        movaps   xmm7,xmm0  ;.n1  ;xmm0
        mulps    xmm7,xmm7 ; normalize
        haddps   xmm7,xmm7
        haddps   xmm7,xmm7
        rsqrtps  xmm7,xmm7
        mulps    xmm7,.n1   ;xmm0
 ;       andps    xmm7,[abs_z_coof]
        movaps   .cnv,xmm7

        movaps   xmm6,xmm2
        minps    xmm6,.tex_m2  ;    float  TEX_X-2,TEX_Y-2
        cvttps2dq xmm7,xmm6
        cvtdq2ps xmm4,xmm7
        subps    xmm6,xmm4
        movlps   .xf,xmm6
        mov      eax,.lights_al   ; global

      .again_col:
        movaps   xmm0,[eax] ; calc multple lights
        mulps    xmm0,.cnv  ;.lv  ; last dword should be zeroed
        haddps   xmm0,xmm0
        haddps   xmm0,xmm0
   ;     andps    xmm0,[abs_val]  ;calc absolute value

        ; stencil
        movhlps   xmm6,xmm2
        movhlps   xmm4,xmm2
        addss     xmm6,.aprox
        subss     xmm4,.aprox
        cmpnltss  xmm6,dword[esi]
        cmpnltss  xmm4,dword[esi]
        xorps     xmm6,xmm4
        xorps     xmm4,xmm4
        movd      ebx,xmm6
        or        ebx,ebx
        jz        .no_reflective

        movaps    xmm4,xmm0
        mulps     xmm4,xmm4
        mulps     xmm4,xmm4
        mulps     xmm4,xmm4
        mulps     xmm4,xmm4
        mulps     xmm4,[eax+48]
        jmp       .skp
     .no_reflective:

        pxor     xmm3,xmm3
        maxps    xmm0,xmm3  ;[the_zero]
        mulps    xmm0,[eax+16]
        addps    xmm4,xmm0

      .skp:
        addps    xmm4,[eax+32]
        maxps    xmm5,xmm4
        add      eax,64
        cmp      eax,.lights_ale
        jnz      .again_col
        minps    xmm5,.mask_255f
          ; texture coords work
        movd     eax,xmm7
        psrldq   xmm7,4
        movd     ebx,xmm7
        shl      ebx,TEX_SHIFT
        add      eax,ebx
        shl      eax,2
        add      eax,.tx_ptr
        mov      ebx,eax
        add      ebx,.texx4  ;TEX_X*4
        movd     xmm7,[eax]
        movd     xmm6,[eax+4]
        movd     xmm4,[ebx]
        movd     xmm3,[ebx+4]
        punpcklbw xmm7,xmm6 ;xmm7 r1 r2 g1 g2 b1 b2
        punpcklbw xmm4,xmm3 ;xmm4 r3 r4 g3 g4 b3 b4
        punpcklwd xmm7,xmm4 ;xmm7 r1 r2 r3 r4 g1 g2 g3 g4 ...
        movdqa    xmm6,xmm7
        movdqa    xmm4,xmm7
        psrldq    xmm6,4
        psrldq    xmm4,8
        pxor      xmm3,xmm3

        punpcklbw xmm7,xmm3
        punpcklbw xmm6,xmm3
        punpcklbw xmm4,xmm3
        punpcklwd xmm7,xmm3
        punpcklwd xmm6,xmm3
        punpcklwd xmm4,xmm3


     ; calc w .........
        movlps   xmm3,.the_one  ;  broadcasted dword 1.0
        cvtdq2ps xmm7,xmm7
        subps    xmm3,.xf
        cvtdq2ps xmm6,xmm6
        movhps   xmm3,.xf
        cvtdq2ps xmm4,xmm4
        movaps   xmm1,xmm3  ; 1-xf, 1-yf, xf, yf
        shufps   xmm3,xmm3,10001000b
        shufps   xmm1,xmm1,11110101b
        mulps    xmm3,xmm1

        mulps    xmm7,xmm3
        mulps    xmm6,xmm3
        mulps    xmm4,xmm3
        haddps   xmm7,xmm7  ; r
        haddps   xmm6,xmm6  ; g
        haddps   xmm4,xmm4  ; b
        haddps   xmm7,xmm7  ; r
        haddps   xmm6,xmm6  ; g
        haddps   xmm4,xmm4  ; b
        movlhps  xmm7,xmm6
        shufps   xmm7,xmm7,11101000b
        movlhps  xmm7,xmm4

        mulps    xmm5,xmm7
        cvtps2dq xmm5,xmm5
        psrld    xmm5,8
        movd     xmm6,[edi]
        packssdw xmm5,xmm5
        packuswb xmm5,xmm5
        paddusb  xmm5,xmm6
        movd     [edi],xmm5
     .skip:
        add      edi,4
        add      esi,4
        movaps   xmm0,.n1     ; cur normal
        addps    xmm0,.dn
        addps    xmm2,.dtx
        movaps   .n1,xmm0
        dec      ecx
        jnz      .ddraw

  .end_line:
        add      esp,300
        pop      ebp

ret
