; Texturing with bilinear filtering, real Phongs shading
; and glass like effect (variable slices buffer for object).
; Implemented in FASM by Maciej Guba.
;
; Thanks to many authors of tutorials and articles
; released in internet. Without them this proc wouldnt arise.



ROUND2 equ 10

;glass_tex_tri_sl_var:
;----Procedure render Phongs shaded horizontal line with-
;----z coord interpolation, each pixel is covered by ----
;----texture using bilinear filtering; with also  some --
;----weighted, sorted (pixel precision) transparency ----
;----effect.. I normalize normal vector in every pixel --

glass_tex_line_sl_var:
; in:
;    xmm0 - normal vector 1
;    xmm1 - normal vect 2
;    xmm3 - lo -> hi tx1, ty1, z1 coords as dwords float
;    xmm5 - lo -> hi tx2, ty2, z2 coords as dwords float
;    xmm2 - lo -> hi y_min, y_max, x_min, x_max
;	    as dword integers
;    xmm4 - normalized light vector ;;; unused now
;    eax - x1
;    ebx - x2
;    ecx - y
;    edi - screen buffer
;    esi - pointer of pointers to slices buffer
;	   Every ptr adress depth history of pixel,
;	   if ptr=0 -> background color, no depth
;	   history.
;    edx - texture pointer (handle)
;    xmm6 - lowest dword x_res as integer

   push  ebp
   mov	 ebp,esp
   sub	 esp,320
   and	 ebp,0xfffffff0

 .gtsvl_n1     equ [ebp-16]
 .gtsvl_n2     equ [ebp-32]

 .gtsvl_yd     equ [ebp-36]
 .gtsvl_xd     equ [ebp-40]
 .gtsvl_yf     equ [ebp-44]
 .gtsvl_xf     equ [ebp-48]

 .gtsvl_dz     equ [ebp-56]
 .gtsvl_dty    equ [ebp-60]
 .gtsvl_dtx    equ [ebp-64]

 .gtsvl_screen equ [ebp-68]
 .gtsvl_zbuff  equ [ebp-72]
 .gtsvl_x_max  equ [ebp-74]
 .gtsvl_x_min  equ [ebp-76]
 .gtsvl_y_max  equ [ebp-78]
 .gtsvl_y_min  equ [ebp-80]

 .gtsvl_dn     equ [ebp-96]
 .gtsvl_x_res  equ [ebp-100]
 .ylvs	       equ [ebp-104]
 .gtsvl_x1     equ [ebp-112]
 .gtsvl_x2     equ [ebp-108]
 .gtsvl_cnv    equ [ebp-112]

 .gtsvl_z1     equ [ebp-120]
 .gtsvl_ty1    equ [ebp-124]
 .gtsvl_tx1    equ [ebp-128]

 .gtsvl_cz     equ [ebp-136]
 .gtsvl_cty    equ [ebp-140]
 .gtsvl_ctx    equ [ebp-144]


 .gtsvl_z2     equ [ebp-152]
 .gtsvl_ty2    equ [ebp-156]
 .gtsvl_tx2    equ [ebp-160]


 .gtsvl_tx_ptr	   equ [ebp-164]
 .gtsvl_cnt_ptr    equ dword[ebp-168]
 .gtsvl_ptrs_ptr   equ dword[ebp-172]
 .gtsvl_sl_c	   equ dword[ebp-176]
 .zzero 	   equ [ebp-192]


	packssdw xmm2,xmm2
	movq	.gtsvl_y_min,xmm2
	cmp	cx,.gtsvl_y_min
	jl	.end_line
	cmp	cx,.gtsvl_y_max
	jge	.end_line
	mov	.ylvs,ecx
	movd	xmm7,[slices_counter_ptr]
	movd	.gtsvl_cnt_ptr,xmm7
	cmp	 eax,ebx
	je	 .end_line
	jl	 @f
	xchg	 eax,ebx
	movaps	 xmm7,xmm0
	movaps	 xmm0,xmm1
	movaps	 xmm1,xmm7
	movaps	 xmm7,xmm3
	movaps	 xmm3,xmm5
	movaps	 xmm5,xmm7
   @@:

	cmp	ax,.gtsvl_x_max
	jge	.end_line
	cmp	bx,.gtsvl_x_min
	jle	.end_line
	movaps	.gtsvl_n1,xmm0
	movaps	.gtsvl_n2,xmm1
	mov	.gtsvl_x1,eax
	mov	.gtsvl_x2,ebx
	movaps	.gtsvl_tx1,xmm3
	movaps	.gtsvl_tx2,xmm5
	movd	.gtsvl_x_res,xmm6
	mov	.gtsvl_tx_ptr,edx
	mov	.gtsvl_ptrs_ptr,esi
	sub	ebx,eax
	cvtsi2ss xmm7,ebx
	rcpss	xmm7,xmm7
	shufps	xmm7,xmm7,0
	subps	xmm1,xmm0
	mulps	xmm1,xmm7
	movaps	.gtsvl_dn,xmm1
	subps	xmm5,xmm3
	mulps	xmm5,xmm7
	movaps	.gtsvl_dtx,xmm5



	mov	 ebx,.gtsvl_x1
	cmp	 bx,.gtsvl_x_min     ; clipping on function4
	jge	 @f
	movzx	 eax,word .gtsvl_x_min
	sub	 eax,ebx
	cvtsi2ss xmm7,eax
	shufps	 xmm7,xmm7,0
	mulps	 xmm5,xmm7
	mulps	 xmm1,xmm7
	addps	 xmm5,.gtsvl_tx1
	addps	 xmm1,.gtsvl_n1
	movsx	 eax,word .gtsvl_x_min
	movaps	 .gtsvl_tx1,xmm5
	movaps	 .gtsvl_n1,xmm1
	mov	 dword .gtsvl_x1,eax

      @@:
	movzx	eax,word .gtsvl_x_max
	cmp	.gtsvl_x2,eax
	jl	@f
	mov	.gtsvl_x2,eax
      @@:
	mov	eax,.gtsvl_x_res
	imul	eax, dword .ylvs
	add	eax,.gtsvl_x1

	add	.gtsvl_cnt_ptr,eax
	mov	esi,.gtsvl_ptrs_ptr

	shl	eax,2
	add	edi,eax
	add	esi,eax

	mov	ecx,.gtsvl_x2
	sub	ecx,.gtsvl_x1
	movaps	xmm2,.gtsvl_tx1
	xorps	xmm5,xmm5
	movaps	.zzero,xmm5

   .ddraw:
	push	  ecx
	   ;variable slices
	mov	  ecx,.gtsvl_cnt_ptr
	movzx	  ecx,byte [ecx]
	or	  ecx,ecx
	jz	  .skip
	xor	  eax,eax
	mov	  edx,[esi]
	or	  edx,edx
	jz	  .skip
     @@:
	movaps	  xmm3,xmm2
	shufps	  xmm3,xmm3,10101010b
	movaps	  xmm0,xmm3
	addps	  xmm3,[aprox]
	subps	  xmm0,[aprox]
	cmpnltss  xmm0,[edx]
	cmpnltss  xmm3,[edx]
	xorps	  xmm0,xmm3
	movd	  ebx,xmm0
	cmp	  ebx,-1
	je	  @f
	add	  eax,1
	cmp	  eax,10 ;visable max to 10 slices
	je	  .skip
	cmp	  eax,ecx
	je	  @f
	add	  edx,4
	jmp	  @b
      @@:
	movzx	 eax,al
	mov	 .gtsvl_sl_c,eax
	; normal
	xorps	 xmm5,xmm5
	movaps	 xmm7,.gtsvl_n1  ;xmm0
	dpps	 xmm7,xmm7,0xff  ;.gtsvl_n1,01110111b
	rsqrtps  xmm7,xmm7
	mulps	 xmm7,.gtsvl_n1
	movaps	 .gtsvl_cnv,xmm7

	movaps	 xmm6,xmm2
	minps	 xmm6,[tex_m2]	;    float  TEX_X-2,TEX_Y-2
	cvttps2dq xmm7,xmm6
	cvtdq2ps xmm4,xmm7
	subps	 xmm6,xmm4
	movlps	 .gtsvl_xf,xmm6


	mov	 eax,lights_aligned   ; global

      .again_col:
	movaps	 xmm0,[eax] ; calc multple lights
	dpps	 xmm0,.gtsvl_cnv,01110111b
   ;	 mulps	  xmm0,.gtsvl_cnv  ;.lv  ; last dword should be zeroed
	xorps	  xmm4,xmm4

	cmp	  .gtsvl_sl_c,0
	jne	  .no_reflective

	movaps	  xmm4,xmm0 ; reflective particle of light equation
	mulps	  xmm4,xmm4 ; only for first front slice.
	mulps	  xmm4,xmm4
	mulps	  xmm4,xmm4
	mulps	  xmm4,xmm4
	mulps	  xmm4,[eax+48]
    ;	 int3
	jmp	  .on_ref

     .no_reflective:
	maxps	 xmm0,.zzero
	mulps	 xmm0,[eax+16]
	addps	 xmm4,xmm0
  ;    .on_ref:
	addps	 xmm4,[eax+32]
      .on_ref:
	maxps	 xmm5,xmm4
	add	 eax,64
	cmp	 eax,lights_aligned_end
	jnz	 .again_col
	minps	 xmm5,[mask_255f]

	  ; texture coords work
	movd	 eax,xmm7
	psrldq	 xmm7,4
	movd	 ebx,xmm7
	shl	 ebx,TEX_SHIFT
	add	 eax,ebx
	shl	 eax,2
	add	 eax,.gtsvl_tx_ptr
	mov	 ebx,eax
	add	 ebx,TEX_X*4
	movd	 xmm7,[eax]
	movd	 xmm6,[eax+4]
	movd	 xmm4,[ebx]
	movd	 xmm3,[ebx+4]
	punpcklbw xmm7,xmm6 ;xmm7 r1 r2 g1 g2 b1 b2
	punpcklbw xmm4,xmm3 ;xmm4 r3 r4 g3 g4 b3 b4
	punpcklwd xmm7,xmm4 ;xmm7 r1 r2 r3 r4 g1 g2 g3 g4 ...
	movdqa	  xmm6,xmm7
	movdqa	  xmm4,xmm7
	psrldq	  xmm6,4
	psrldq	  xmm4,8


	pmovzxbd  xmm7,xmm7
	pmovzxbd  xmm6,xmm6
	pmovzxbd  xmm4,xmm4


     ; calc w .........
	movlps	 xmm3,[the_one]  ;  broadcasted dword 1.0
	cvtdq2ps  xmm7,xmm7
	subps	 xmm3,.gtsvl_xf
	cvtdq2ps  xmm6,xmm6
	movhps	 xmm3,.gtsvl_xf
	cvtdq2ps  xmm4,xmm4
	movaps	 xmm1,xmm3  ; 1-xf, 1-yf, xf, yf
	shufps	 xmm3,xmm3,10001000b
	shufps	 xmm1,xmm1,11110101b
	mulps	 xmm3,xmm1


	dpps	 xmm7,xmm3,0xff
	dpps	 xmm6,xmm3,0xff
	dpps	 xmm4,xmm3,0xff

	movlhps  xmm7,xmm6
	shufps	 xmm7,xmm7,11101000b
	movlhps  xmm7,xmm4

	mulps	  xmm5,xmm7

    ;	 sub	   .gtsvl_sl_c,10
    ;	 neg	   .gtsvl_sl_c
	mov	  eax,.gtsvl_sl_c
	mov	  ecx,6
	cmp	  eax,ecx
	cmova	  eax,ecx
	shl	  eax,4
	add	  eax,slices_factor1
     ;	 cvtsi2ss  xmm0,.gtsvl_sl_c
     ;	 mulss	   xmm0,[peeling_particle]
     ;	 shufps    xmm0,xmm0,0
	mulps	  xmm5,[eax]  ;xmm0
     .final:

	minps	  xmm5,[word_max_f]
	cvtps2dq  xmm5,xmm5
	psrld	  xmm5,8
	movd	  xmm6,[edi]
	packssdw  xmm5,xmm5
	packuswb  xmm5,xmm5
	paddusb   xmm5,xmm6
	movd	  [edi],xmm5
      .skip:
	add	 edi,4
	add	 esi,4
	inc	 .gtsvl_cnt_ptr
	movaps	 xmm0,.gtsvl_n1     ; cur normal
	addps	 xmm0,.gtsvl_dn
	addps	 xmm2,.gtsvl_dtx
	movaps	 .gtsvl_n1,xmm0
	pop	 ecx
	dec	 ecx
	jnz	 .ddraw

  .end_line:
	add	 esp,320
	pop	 ebp

ret
