ROUND equ 8
CATMULL_SHIFT equ 8
gouraud_triangle_z:

;----procedure drawing gouraud triangle with z coordinate
;----interpolation ( Catmull alghoritm )-----------------
;------------------in - eax - x1 shl 16 + y1 ------------
;---------------------- ebx - x2 shl 16 + y2 ------------
;---------------------- ecx - x3 shl 16 + y3 ------------
;---------------------- esi - pointer to Z-buffer--------
;---------------------- Z-buffer filled with dd variables
;---------------------- shifted CATMULL_SHIFT------------
;---------------------- edi - pointer to screen buffer---
;---------------------- stack : colors-------------------
;----------------- procedure don't save registers !!-----
.col1r equ ebp+8   ; each color as word
.col1g equ ebp+10  ; each z coordinate as word
.col1b equ ebp+12
.z1    equ ebp+14
.col2r equ ebp+16
.col2g equ ebp+18
.col2b equ ebp+20
.z2    equ ebp+22
.col3r equ ebp+24
.col3g equ ebp+26
.col3b equ ebp+28
.z3    equ ebp+30
.y_min equ [ebp+32]
.y_max equ [ebp+34]

.x1    equ word[ebp-2]
.y1    equ word[ebp-4]
.x2    equ word[ebp-6]
.y2    equ word[ebp-8]
.x3    equ word[ebp-10]
.y3    equ [ebp-12]

.dx12  equ dword[ebp-16]
.dz12  equ dword[ebp-20]
.dc12r equ dword[ebp-24]
.dc12g equ dword[ebp-28]
.dc12b equ [ebp-32]

.dx13  equ dword[ebp-36]
.dz13  equ dword[ebp-40]
.dc13r equ dword[ebp-44]
.dc13g equ dword[ebp-48]
.dc13b equ [ebp-52]

.dx23  equ dword[ebp-56]
.dz23  equ dword[ebp-60]
.dc23r equ dword[ebp-64]
.dc23g equ dword[ebp-68]
.dc23b equ [ebp-72]

.zz1   equ dword[ebp-76]
.c1r   equ dword[ebp-80]
.c1g   equ dword[ebp-84]
.c1b   equ [ebp-88]
.zz2   equ dword[ebp-92]
.c2r   equ dword[ebp-96]
.c2g   equ dword[ebp-100]
.c2b   equ [ebp-104]



       push     ebp
       mov      ebp,esp

 .sort3:                  ; sort triangle coordinates...
       cmp      ax,bx
       jle      .sort1
       xchg     eax,ebx
       movups   xmm0,[.col1r]
       movlps   [.col2r],xmm0
       movhps   [.col1r],xmm0
 .sort1:
       cmp      bx,cx
       jle      .sort2
       xchg     ebx,ecx
       movups   xmm0,[.col2r]
       movhps   [.col2r],xmm0
       movlps   [.col3r],xmm0
       jmp      .sort3
 .sort2:
       push     eax          ; store in variables
       push     ebx
       push     ecx


       ; check was prev - draw_thrd.inc


       mov      bx,.y2       ; calc deltas
       sub      bx,.y1
       jnz      .gt_dx12_make
       mov      ecx,5
     @@:
       push     dword 0
       loop     @b
       jmp      .gt_dx12_done
  .gt_dx12_make:


       movsx    ebx,bx
       mov      eax,1 shl 15
       cdq
       idiv     ebx
       mov      ebx,eax

       mov      ax,.x2
       sub      ax,.x1
       cwde
       imul     ebx
       sar      eax,15 - ROUND
       push     eax

       sub       esp,4*4
       movd      xmm0,ebx
       pshuflw   xmm0,xmm0,0
       movq      xmm1,[.col1r]
       movq      xmm2,[.col2r]
       psubw     xmm2,xmm1
       movdqa    xmm3,xmm2
       pmullw    xmm2,xmm0
       pmulhw    xmm3,xmm0
       punpcklwd xmm2,xmm3
       psrad     xmm2,15 - ROUND
       pshufd    xmm2,xmm2,11000110b
       movdqu    .dc12b,xmm2
   .gt_dx12_done:

       mov      bx,.y3       ; calc deltas
       sub      bx,.y1
       jnz      .gt_dx13_make
       mov      ecx,5
     @@:
       push     dword 0
       loop     @b
       jmp      .gt_dx13_done
    .gt_dx13_make:


       movsx    ebx,bx
       mov      eax,1 shl 15
       cdq
       idiv     ebx
       mov      ebx,eax


       mov      ax,.x3
       sub      ax,.x1
       cwde
       imul     ebx
       sar      eax,15 - ROUND
       push     eax

       sub       esp,4*4
       movd      xmm0,ebx
       pshuflw   xmm0,xmm0,0
       movq      xmm1,[.col1r]
       movq      xmm2,[.col3r]
       psubw     xmm2,xmm1
       movdqa    xmm3,xmm2
       pmullw    xmm2,xmm0
       pmulhw    xmm3,xmm0
       punpcklwd xmm2,xmm3
       psrad     xmm2,15 - ROUND
       pshufd    xmm2,xmm2,11000110b
       movdqu    .dc13b,xmm2

   .gt_dx13_done:

       mov      bx,.y3       ; calc deltas
       sub      bx,.y2
       jnz      .gt_dx23_make
       mov      ecx,5
     @@:
       push     dword 0
       loop     @b
       jmp      .gt_dx23_done
    .gt_dx23_make:


       movsx    ebx,bx
       mov      eax,1 shl 15
       cdq
       idiv     ebx
       mov      ebx,eax

       mov      ax,.x3
       sub      ax,.x2
       cwde
       imul     ebx
       sar      eax,15 - ROUND
       push     eax

       sub       esp,4*4
       movd      xmm0,ebx
       pshuflw   xmm0,xmm0,0
       movq      xmm1,[.col2r]
       movq      xmm2,[.col3r]
       psubw     xmm2,xmm1
       movdqa    xmm3,xmm2
       pmullw    xmm2,xmm0
       pmulhw    xmm3,xmm0
       punpcklwd xmm2,xmm3
       psrad     xmm2,15 - ROUND
       pshufd    xmm2,xmm2,11000110b
       movdqu    .dc23b,xmm2

   .gt_dx23_done:
       sub      esp,32

       movsx     eax,.x1                    ; eax - cur x1
       shl       eax,ROUND                  ; ebx - cur x2
       mov       ebx,eax
       pxor      xmm7,xmm7
       movq      xmm0,[.col1r]
       punpcklwd xmm0,xmm7
       pslld     xmm0,ROUND
       pshufd    xmm0,xmm0,11000110b
       movdqu    .c1b,xmm0
       movdqu    .c2b,xmm0
       movdqu    xmm1,xmm0

       movsx    edx,word[.z1]
       shl      edx,CATMULL_SHIFT
       mov      .zz1,edx
       mov      .zz2,edx

       mov      cx,.y1
       cmp      cx,.y2
       jge      .gt_loop1_end

    .gt_loop1:
       pushad

       push     word .y_max
       push     word .y_min
       psrad    xmm0,ROUND
       psrad    xmm1,ROUND
       packssdw xmm0,xmm0
       packssdw xmm1,xmm1
       movlhps  xmm0,xmm1
       psllq    xmm0,16
       movups   [esp-16],xmm0

       sub      esp,6
       sar      ebx,ROUND
       push     bx
       sub      esp,6
       sar      eax,ROUND
       push     ax

       push     cx
       push     .zz2
       push     .zz1

       call     gouraud_line_z

       popad

       movdqu   xmm0,.c1b
       movdqu   xmm1,.c2b
       movdqu   xmm2,.dc13b
       movdqu   xmm3,.dc12b
       paddd    xmm0,xmm2
       paddd    xmm1,xmm3
       movdqu   .c1b,xmm0
       movdqu   .c2b,xmm1

       add      eax,.dx13
       add      ebx,.dx12
       inc      cx
       cmp      cx,.y2
       jl       .gt_loop1
   .gt_loop1_end:
       mov      cx,.y2
       cmp      cx,.y3
       jge      .gt_loop2_end

       movsx    ebx,.x2                    ; eax - cur x1
       shl      ebx,ROUND                  ; ebx - cur x2


       pxor      xmm7,xmm7
       movq      xmm1,[.col2r]
       punpcklwd xmm1,xmm7
       pslld     xmm1,ROUND
       pshufd    xmm1,xmm1,11000110b
       movdqu    .c2b,xmm1
       movdqu    xmm0,.c1b


       movsx    edx,word[.z2]
       shl      edx,CATMULL_SHIFT
       mov      .zz2,edx


    .gt_loop2:
       pushad

       push     word .y_max
       push     word .y_min


       psrad    xmm0,ROUND
       psrad    xmm1,ROUND
       packssdw xmm0,xmm0
       packssdw xmm1,xmm1
       movlhps  xmm0,xmm1
       psllq    xmm0,16
       movups   [esp-16],xmm0

       sub      esp,6
       sar      ebx,ROUND    ; x2
       push     bx
       sub      esp,6
       sar      eax,ROUND
       push     ax            ; x1



       push     cx            ; y
       push     .zz2
       push     .zz1

       call     gouraud_line_z

       popad

       movdqu   xmm0,.c1b
       movdqu   xmm1,.c2b
       movdqu   xmm2,.dc13b
       movdqu   xmm3,.dc23b
       paddd    xmm0,xmm2
       paddd    xmm1,xmm3
       movdqu   .c1b,xmm0
       movdqu   .c2b,xmm1


       add      eax,.dx13
       add      ebx,.dx23
       inc      cx
       cmp      cx,.y3

       jl       .gt_loop2
   .gt_loop2_end:

       mov      esp,ebp
       pop      ebp
ret 28

gouraud_line_z:
;----------------- procedure drawing gouraud line
;----------------- with z coordinate interpolation
;----------------- esi - pointer to Z_buffer
;----------------- edi - pointer to screen buffer
;----------------- stack:
.z1  equ dword[ebp+4]   ; z coordiunate shifted left CATMULL_SHIFT
.z2  equ dword[ebp+8]
.y   equ word[ebp+12]
.x1  equ ebp+14
.c1b equ ebp+16
.c1g equ ebp+18
.c1r equ ebp+20
.x2  equ ebp+22
.c2b equ ebp+24
.c2g equ ebp+26
.c2r equ ebp+28
.y_min equ [ebp+30]
.y_max equ [ebp+32]

.dz     equ dword[ebp-4]
.dc_b   equ [ebp-8]
.dc_g   equ dword[ebp-12]
.dc_r   equ [ebp-16]
.c_z    equ dword[ebp-20]


        mov       ebp,esp

        mov     ax,.y
        cmp     ax,.y_min
        jl      .gl_quit
        cmp     ax,.y_max
        jge     .gl_quit

        mov     eax,dword[.x1]
        cmp     ax,word[.x2]
        je      .gl_quit
        jl      @f
        movups  xmm0,[.x1]
        movhps  [.x1],xmm0
        movd    xmm3,.z1
        movd    xmm4,.z2
        movq    [.x2],xmm0
        movd    .z1,xmm4
        movd    .z2,xmm3
   @@:
        mov     ax,[xres_var]
        cmp     word[.x1],ax
        jge     .gl_quit
        cmp     word[.x2],0
        jle     .gl_quit

        mov     bx,word[.x2]      ; dz = z2-z1/x2-x1
        sub     bx,word[.x1]
        movsx   ebx,bx
        mov   eax,1 shl 15
        cdq
        idiv  ebx
        mov   ecx,.z2
        sub   ecx,.z1
        imul  ecx,eax
        sar   ecx,15
        push  ecx

        mov     cx,word[.c2b]
        sub     cx,word[.c1b]
        movsx   ecx,cx
        imul    ecx,eax
        sar     ecx,15 - ROUND
        push    ecx


        mov     cx,word[.c2g]
        sub     cx,word[.c1g]
        movsx   ecx,cx
        imul    ecx,eax
        sar     ecx,15 - ROUND
        push    ecx


        mov     cx,word[.c2r]
        sub     cx,word[.c1r]
        movsx   ecx,cx
        ; dc_r = c2r-c1r/x2-x1
        imul    ecx,eax
        sar     ecx,15 - ROUND
        push    ecx


        cmp     word[.x1],0     ; clipping on function
        jg      @f
        mov     eax,.dz
        movsx   ebx,word[.x1]
        neg     ebx
        imul    ebx
        add     .z1,eax
        mov     word[.x1],0

        mov     eax,.dc_r
        imul    ebx
        sar     eax,ROUND
        add     word[.c1r],ax

        mov     eax,.dc_g
        imul    ebx
        sar     eax,ROUND
        add     word[.c1g],ax

        mov     eax,.dc_b
        imul    ebx
        sar     eax,ROUND
        add     word[.c1b],ax

      @@:
        mov     ax,[xres_var]
        cmp     word[.x2],ax
        jl      @f
        mov     word[.x2],ax
     @@:
        sub     esp,128        ; calculate memory begin
        movzx   edx,[xres_var] ; in buffers
        movzx   eax,.y
        mul     edx
        movzx   edx,word[.x1]
        add     eax,edx
        shl     eax,2
        add     edi,eax
        add     esi,eax

        mov     cx,word[.x2]
        sub     cx,word[.x1]
        movzx   ecx,cx


      pxor      xmm3,xmm3
      mov       ebx,.z1  ; ebx -> cur z
      movq      xmm1,[.c1b]
      punpcklwd xmm1,xmm3
      pslld     xmm1,ROUND
      movdqu    xmm2,.dc_r
      shufps    xmm2,xmm2,11000110b

   .ddraw:
     cmp        ebx,dword[esi]
     jge        @f
     mov        dword[esi],ebx
     movdqa     xmm0,xmm1
     psrld      xmm0,ROUND
     pshufd     xmm0,xmm0,11000110b
     packssdw   xmm0,xmm0
     packuswb   xmm0,xmm0
     movd       [edi],xmm0

   @@:
     add        esi,4
     add        edi,4
     add        ebx,.dz
     paddd      xmm1,xmm2
     loop       .ddraw


   .gl_quit:

     mov       esp,ebp
ret 30

