

CATMULL_SHIFT  equ 8
ROUND equ 8
; procedure drawing textured triangle with Gouraud shading
; Z-buffer alghoritm included, Z coord interpolation ----
; I set the color by this way -- (col1 * col2)/256 ------
;------------------in - eax - x1 shl 16 + y1 ------------
;---------------------- ebx - x2 shl 16 + y2 ------------
;---------------------- ecx - x3 shl 16 + y3 ------------
;---------------------- esi - pointer to Z-buffer--------
;---------------------- edx - pointer to texture---------
;---------------------- Z-buffer filled with dd variables
;---------------------- shifted CATMULL_SHIFT------------
;---------------------- edi - pointer to screen buffer---
;---------------------- stack : colors,z ..--------------



tex_plus_grd_triangle:
; parameters :
   .y_max   equ [ebp+46]
   .y_min   equ [ebp+44]

   .tex_y3  equ [ebp+42]   ; 40 bytes through stack
   .tex_x3  equ [ebp+40]
   .tex_y2  equ [ebp+38]
   .tex_x2  equ [ebp+36]
   .tex_y1  equ [ebp+34]
   .tex_x1  equ [ebp+32]

   .z3	    equ [ebp+30]
   .col3b   equ [ebp+28]
   .col3g   equ [ebp+26]
   .col3r   equ [ebp+24]

   .z2	    equ [ebp+22]
   .col2b   equ [ebp+20]
   .col2g   equ [ebp+18]
   .col2r   equ [ebp+16]

   .z1	    equ [ebp+14]
   .col1b   equ [ebp+12]
   .col1g   equ [ebp+10]
   .col1r   equ [ebp+8]

; local variables:

   .tex_ptr   equ dword[ebp-4]
   .z_ptr     equ dword[ebp-8]
   .scr_buff  equ dword[ebp-12]

   .x1	      equ  word[ebp-14]
   .y1	      equ  word[ebp-16]
   .x2	      equ  word[ebp-18]
   .y2	      equ  word[ebp-20]
   .x3	      equ  word[ebp-22]
   .y3	      equ  [ebp-24]

   .dx12      equ  dword[ebp-28]
   .tex_dy12  equ	[ebp-32]
   .tex_dx12  equ	[ebp-36]
   .dz12      equ  dword[ebp-40]
   .dc12r     equ	[ebp-44]
   .dc12g     equ  dword[ebp-48]
   .dc12b     equ	[ebp-52]

   .dx23      equ  dword[ebp-56]
   .tex_dy23  equ	[ebp-60]
   .tex_dx23  equ	[ebp-64]
   .dz23      equ  dword[ebp-68]
   .dc23r     equ	[ebp-72]
   .dc23g     equ  dword[ebp-76]
   .dc23b     equ	[ebp-80]

   .dx13      equ  dword[ebp-84]
   .tex_dy13  equ	[ebp-88]
   .tex_dx13  equ	[ebp-92]
   .dz13      equ  dword[ebp-96]
   .dc13r     equ	[ebp-100]
   .dc13g     equ  dword[ebp-104]
   .dc13b     equ	[ebp-108]

   .scan_y1   equ	[ebp-112]
   .scan_x1   equ	[ebp-116]
   .zz1       equ  dword[ebp-120]
   .cur1r     equ	[ebp-124]
   .cur1g     equ	[ebp-128]
   .cur1b     equ	[ebp-132]

   .scan_y2   equ	[ebp-136]
   .scan_x2   equ	[ebp-140]
   .zz2       equ	[ebp-144]
   .cur2r     equ	[ebp-148]
   .cur2g     equ	[ebp-152]
   .cur2b     equ	[ebp-156]

       push    ebp
       mov    ebp,esp

       push    edx esi edi

   .sort3:
       cmp     ax,bx
       jle     .sort1
       xchg    eax,ebx

       movups  xmm0, .col1r	  ; exchange r, g, b, z
       movhps  .col1r ,xmm0
       movlps  .col2r ,xmm0

       movd    xmm1,.tex_x1
       movd    xmm2,.tex_x2
       movd    .tex_x1,xmm2
       movd    .tex_x2,xmm1


 .sort1:
       cmp	bx,cx
       jle	.sort2
       xchg    ebx,ecx

       movups  xmm0, .col2r	  ; exchange r, g, b, z
       movlps  .col3r ,xmm0
       movhps	.col2r ,xmm0

       movd    xmm1,.tex_x3
       movd    xmm2,.tex_x2
       movd    .tex_x3,xmm2
       movd    .tex_x2,xmm1


       jmp .sort3

 .sort2:


       push	eax	     ; store in variables
       push	ebx
       push	ecx

    ; check was prev - draw_thrd.inc
   if 0

	movups	xmm0,.y3		; check if at last only fragment
	pand	xmm0,[draw_thread_mask] ; of triangle is in visable area
	movd	xmm1,.y_min
	packssdw xmm0,xmm0
	pshuflw xmm2,xmm1,01010101b
	pshuflw xmm1,xmm1,0
	movdqa	xmm3,xmm0
	pcmpgtw xmm3,xmm2
	pcmpgtw xmm0,xmm1
	pxor	xmm0,xmm3
	pmovmskb eax,xmm0
	and	al,00111111b
	or	al,al
	jz	.loop2_end

   end if
;****************** delta computng zone **************

       mov	bx,.y2	     ; calc delta12
       sub	bx,.y1
       jnz	.dx12_make
       mov	ecx,7
     @@:
       push	dword 0
       loop	@b
       jmp	.dx12_done
  .dx12_make:

       movsx	ebx,bx
       mov	eax,1 shl 15
       cdq
       idiv	ebx
       mov	ebx,eax


       mov	ax,.x2
       sub	ax,.x1
       cwde
       imul	ebx
       sar	eax,15 - ROUND
       push	eax

       sub	 esp,6*4
       movd	 xmm0,ebx
       pshuflw	 xmm0,xmm0,0
    ;	pshufd	  xmm0,xmm0,0
       movlhps	 xmm0,xmm0
       movq	 xmm1,.col1r
       movq	 xmm2,.col2r
       movhps	 xmm1,.tex_x1
       movhps	 xmm2,.tex_x2
       psubw	 xmm2,xmm1
       movdqa	 xmm3,xmm2
       pmullw	 xmm2,xmm0
       pmulhw	 xmm3,xmm0
       movhlps	 xmm4,xmm2
       movhlps	 xmm5,xmm3
       punpcklwd xmm2,xmm3
       punpcklwd xmm4,xmm5
       psrad	 xmm2,15 - ROUND
       psrad	 xmm4,15 - ROUND
       pshufd	 xmm2,xmm2,11000110b
       movdqu	 .dc12b,xmm2
   ;	punpcklwd xmm4,xmm5
    ;	psrad	  xmm4,15 - ROUND
       movq	 .tex_dx12,xmm4


;+++++++++++++++++ second zone +++++++++++++
   .dx12_done:

       mov	bx,.y3	     ; calc delta23
       sub	bx,.y2
       jnz	.dx23_make
       mov	ecx,7
    @@:
       push	dword 0
       loop	@b
       jmp	.dx23_done

  .dx23_make:
       movsx	ebx,bx
       mov	eax,1 shl 15
       cdq
       idiv	ebx
       mov	ebx,eax


       mov	ax,.x3
       sub	ax,.x2
       cwde
       imul	ebx
       sar	eax,15 - ROUND
       push	eax

       sub	 esp,6*4
       movd	 xmm0,ebx
       pshuflw	 xmm0,xmm0,0
       movlhps	 xmm0,xmm0
       movq	 xmm1,.col2r
       movq	 xmm2,.col3r
       movhps	 xmm1,.tex_x2
       movhps	 xmm2,.tex_x3
       psubw	 xmm2,xmm1
       movdqa	 xmm3,xmm2
       pmullw	 xmm2,xmm0
       pmulhw	 xmm3,xmm0
       movhlps	 xmm4,xmm2
       movhlps	 xmm5,xmm3
       punpcklwd xmm2,xmm3
       punpcklwd xmm4,xmm5
       psrad	 xmm2,15 - ROUND
       psrad	 xmm4,15 - ROUND
       pshufd	 xmm2,xmm2,11000110b
       movdqu	 .dc23b,xmm2
       movq	 .tex_dx23,xmm4


   .dx23_done:
;++++++++++++++++++third zone++++++++++++++++++++++++
       mov	bx,.y3	     ; calc delta13
       sub	bx,.y1
       jnz	.dx13_make
       mov	ecx,7
     @@:
       push	dword 0
       loop	@b
       jmp	.dx13_done
  .dx13_make:
       movsx	ebx,bx
       mov	eax,1 shl 15
       cdq
       idiv	ebx
       mov	ebx,eax


       mov	ax,.x3
       sub	ax,.x1
       cwde
       imul	ebx
       sar	eax,15 - ROUND
       push	eax

       sub	 esp,6*4
       movd	 xmm0,ebx
       pshuflw	 xmm0,xmm0,0
       movlhps	 xmm0,xmm0
       movq	 xmm1,.col1r
       movq	 xmm2,.col3r
       movhps	 xmm1,.tex_x1
       movhps	 xmm2,.tex_x3
       psubw	 xmm2,xmm1
       movdqa	 xmm3,xmm2
       pmullw	 xmm2,xmm0
       pmulhw	 xmm3,xmm0
       movhlps	 xmm4,xmm2
       movhlps	 xmm5,xmm3
       punpcklwd xmm2,xmm3
       punpcklwd xmm4,xmm5
       psrad	 xmm2,15 - ROUND
       psrad	 xmm4,15 - ROUND
       pshufd	 xmm2,xmm2,11000110b
       movdqu	 .dc13b,xmm2
       movq	 .tex_dx13,xmm4
   .dx13_done:


; <<<<<<<  ::delta zone end+++++++++++++++++++++ >>>>>>>>

       sub	esp,(12*4)

       movsx	eax,.x1 		   ; eax - cur x1
       shl	eax,ROUND		   ; ebx - cur x2
       mov	ebx,eax


       pxor	 xmm7,xmm7
       movd	 xmm4,.tex_x1
       punpcklwd xmm4,xmm7
       pslld	 xmm4,ROUND
       movq	 .scan_x1,xmm4
       movq	 .scan_x2,xmm4
       movdqa	 xmm5,xmm4


       movq	  xmm0,.col1r
       punpcklwd  xmm0,xmm7
       pslld	  xmm0,ROUND
       pshufd	  xmm0,xmm0,11000110b
       movdqu	  .cur1b,xmm0
       movdqu	  .cur2b,xmm0
       movdqa	  xmm2,xmm0


       movsx	edx,word .z1
       shl	edx,CATMULL_SHIFT
       mov	.zz1,edx
       mov	.zz2,edx

       mov	cx,.y1
       cmp	cx,.y2
       jge	.loop1_end
    .loop_1:

       pushad
       push	 dword .y_min
       push	.tex_ptr
       push	.scr_buff
       push	.z_ptr
       push	cx


       movdqu	[esp-16],xmm2
       push	dword .zz2
       sub	esp,12

       push	dword .scan_x2
       push	dword .scan_y2

       movdqu	[esp-16],xmm0
       push	.zz1
       sub	esp,12
;	movq	 [esp],xmm4
       push	dword .scan_x1
       push	dword .scan_y1


       sar	eax,ROUND
       sar	ebx,ROUND
       call	horizontal_tex_grd_line


       popad


       movups	xmm0,.cur1b
       movups	xmm1,.dc13b
       movups	xmm2,.cur2b
       movups	xmm3,.dc12b
       movq	xmm4,.scan_x1
       movq	xmm5,.scan_x2
       movq	xmm6,.tex_dx13
       movq	xmm7,.tex_dx12
       paddd	xmm0,xmm1
       paddd	xmm2,xmm3
       paddd	xmm4,xmm6  ;.tex_dx13
       paddd	xmm5,xmm7  ;.tex_dx12
       movq	.scan_x1,xmm4
       movq	.scan_x2,xmm5
       movups	.cur1b,xmm0
       movups	.cur2b,xmm2
       pshufd	xmm0,xmm0,11000110b
       pshufd	xmm2,xmm2,11000110b

       add	eax,.dx13
       add	ebx,.dx12
       inc	cx
       cmp	cx,.y2
       jl      .loop_1
 .loop1_end:
       movzx	ecx,.y2
       cmp	cx,.y3
       jge	.loop2_end

       movsx	ebx,.x2 		   ; eax - cur x1
       shl	ebx,ROUND		   ; ebx - cur x2

       movsx	edx,word .z2
       shl	edx,CATMULL_SHIFT
;	mov	 .zz1,edx
       mov	.zz2,edx

       movzx	edi,word .col2r
       shl	edi,ROUND
   ;	mov	 .cur1r,edi
       mov	.cur2r,edi
       movzx	esi,word .col2g
       shl	esi,ROUND
   ;	mov	 .cur1g,esi
       mov	.cur2g,esi
       movzx	edx,word .col2b
       shl	edx,ROUND
   ;	mov	 .cur1b,edx
       mov	.cur2b,edx

       movzx	edi,word .tex_x2
       shl	edi,ROUND
 ;	mov	 .scan_x1,edi
       mov	.scan_x2,edi
       movzx	edx,word .tex_y2
       shl	edx,ROUND
 ;	mov	 .scan_y1,edx
       mov	.scan_y2,edx

  .loop_2:
       pushad
       push	 dword .y_min
       push	.tex_ptr
       push	.scr_buff
       push	.z_ptr
       push	cx

       push	dword .zz2

       push	dword .cur2b
       push	dword .cur2g
       push	dword .cur2r
       push	dword .scan_x2
       push	dword .scan_y2

       push	 .zz1

       push	dword .cur1b
       push	dword .cur1g
       push	dword .cur1r
       push	dword .scan_x1
       push	dword .scan_y1

       sar	eax,ROUND
       sar	ebx,ROUND
       call	horizontal_tex_grd_line

       popad


       movups	xmm0,.cur1b
       movups	xmm1,.dc13b
       movups	xmm2,.cur2b
       movups	xmm3,.dc23b
       movq	mm2,.scan_x1
       movq	mm5,.scan_x2
       paddd	xmm0,xmm1
       paddd	xmm2,xmm3
       paddd	mm2,.tex_dx13
       paddd	mm5,.tex_dx23
       movq	.scan_x1,mm2
       movq	.scan_x2,mm5
       movups	.cur1b,xmm0
       movups	.cur2b,xmm2

       add	eax,.dx13
       add	ebx,.dx23
       inc	cx
       cmp	cx,.y3
       jl	.loop_2

.loop2_end:

       mov	esp,ebp
       pop	ebp
ret 40
horizontal_tex_grd_line:
;in:
; eax : x1, ebx : x2
.y_max	  equ [ebp+68]
.y_min	  equ [ebp+66]
.tex_ptr  equ [ebp+62]
.screen   equ [ebp+58]
.z_buffer equ [ebp+54]
.y	  equ [ebp+52]

.z2	equ [ebp+48]
.b2	equ [ebp+44]
.g2	equ [ebp+40]
.r2	equ [ebp+36]
.tex_x2 equ [ebp+32]
.tex_y2 equ [ebp+28]


.z1	equ [ebp+24]
.b1	equ [ebp+20]
.g1	equ [ebp+16]
.r1	equ [ebp+12]
.tex_x1 equ [ebp+8]
.tex_y1 equ [ebp+4]


.x1 equ  word[ebp-2]
.x2 equ  word[ebp-4]
.dz equ dword[ebp-8]
.db equ [ebp-12]
.dg equ dword[ebp-16]
.dr equ [ebp-20]
.dtex_x equ dword[ebp-24]
.dtex_y equ [ebp-28]

	mov	ebp,esp

	mov	cx,word .y
	cmp	cx,.y_min

	jl	.quit_l

	cmp	cx,.y_max
	jge	.quit_l

	cmp	ax,bx
	je	.quit_l
	jl	@f

	xchg	eax,ebx

	movdqu	xmm0,.tex_y1
	movdqu	xmm1,.tex_y2
	movdqu	.tex_y1,xmm1
	movdqu	.tex_y2,xmm0
	movq	xmm4,.b1    ; x, z
	movq	xmm5,.b2
	movq	.b1,xmm5
	movq	.b2,xmm4

    @@:
	or	bx,bx
	jle	.quit_l
	cmp	ax,[xres_var]	 ;SIZE_X
	jge	.quit_l

	push	ax
	push	bx

	mov	bx,.x2
	sub	bx,.x1

	movsx	 ebx,bx
	mov	 eax,1 shl 15
	cdq
	idiv	 ebx
	mov	 ebx,eax


	mov	eax,.z2 	   ; delta zone************
	sub	eax,.z1
	imul	ebx
	sar	eax,15
	push	eax  ; .dz

	mov	eax,.b2
	sub	eax,.b1
	imul	ebx
	sar	eax,15
	push	eax

	mov	eax,.g2
	sub	eax,.g1
	imul	ebx
	sar	eax,15
	push	eax  ; .dz

	mov	eax,.r2
	sub	eax,.r1
	imul	ebx
	sar	eax,15
	push	eax

	mov	eax,.tex_x2
	sub	eax,.tex_x1
	imul	ebx
	sar	eax,15
	push	eax

	mov	eax,.tex_y2
	sub	eax,.tex_y1
	imul	ebx
	sar	eax,15
	push	eax



if 0
       sub	 esp,6*4
       movd	 xmm0,ebx
       pshuflw	 xmm0,xmm0,0
       movlhps	 xmm0,xmm0
       movdqu	 xmm1,.tex_y1
       movdqu	 xmm2,.tex_y2
       movq	 xmm3,.b1
       movq	 xmm4,.b2
       psubd	 xmm4,xmm3
       psubd	 xmm2,xmm1
       packssdw  xmm2,xmm4
  ;	packlssdw  xmm2,xmm2
   ;	movlhps   xmm2,xmm4


   ;	psubw	  xmm2,xmm1
       movdqa	 xmm3,xmm2
       pmullw	 xmm2,xmm0
       pmulhw	 xmm3,xmm0
       movhlps	 xmm4,xmm2
       movhlps	 xmm5,xmm3
       punpcklwd xmm2,xmm3
       punpcklwd xmm4,xmm5
       psrad	 xmm2,15 - ROUND
       psrad	 xmm4,15 - ROUND
   ;	pshufd	  xmm2,xmm2,11000110b
       movdqu	 .dtex_y,xmm2
       movq	 .db,xmm4


end if

	cmp	.x1,0
	jg	@f

	mov	eax,.dz     ; clipping
	movsx	ebx,.x1
	neg	ebx
	imul	ebx
	add	.z1,eax
	mov	.x1,0

	mov    eax,.dr
	imul   ebx
	add    .r1,eax

	mov    eax,.dg
	imul   ebx
	add    .g1,eax

	mov    eax,.db
	imul   ebx
	add    .b1,eax

	mov    eax,.dtex_x
	imul   ebx
	add    .tex_x1,eax

	mov    eax,.dtex_y
	imul   ebx
	add    .tex_y1,eax
   @@:
	movsx	  edx,[xres_var]
	cmp	  .x2,dx
	jl	  @f
	mov	  .x2,dx
    @@:
; calc line addres begin in screen and Z buffer
	movsx	  eax,word .y
	mul	  edx
	movsx	  edx,.x1
	add	  eax,edx

	mov	  esi,eax
	shl	  esi,2
	add	  esi,.z_buffer

	shl	  eax,2
	mov	  edi,.screen
	add	  edi,eax

	mov	  cx,.x2
	sub	  cx,.x1
	movzx	  ecx,cx

; init current variables
	movdqu	  xmm0,.r1
	movdqu	  xmm1,.dr
	pxor	  xmm2,xmm2
	movq	  xmm4,.dtex_y
	movq	  xmm5,.tex_y1

	mov	  ebx,.z1
      .ddraw:
	cmp	  ebx,dword[esi]
	jge	  @f
	movdqa	  xmm6,xmm5
	psrld	  xmm6,ROUND
	movd	  eax,xmm6
	psrldq	  xmm6,4
	movd	  edx,xmm6
	shl	  eax,TEX_SHIFT

   ; calc texture pixel mem addres

       add	 eax,edx
       and	 eax,TEXTURE_SIZE   ; cutting
       shl	 eax,2
       add	 eax,.tex_ptr
       mov	 dword[esi],ebx

       movd	 xmm7,[eax]
       punpcklbw xmm7,xmm2
       movdqa	 xmm3,xmm0   ; calc col
       psrld	 xmm3,ROUND  ;
       packssdw  xmm3,xmm3
       pmullw	 xmm7,xmm3
       psrlw	 xmm7,8
       packuswb  xmm7,xmm7
       movd	 [edi],xmm7

       mov	  dword[esi],ebx
     @@:
       add	  edi,4
       add	  esi,4
       add	  ebx,.dz
       paddd	  xmm5,xmm4
       paddd	  xmm0,xmm1

       loop	.ddraw

  .quit_l:

	mov	esp,ebp
ret 42+20+4  ; horizontal line

