; Real Phongs shading implemented if flat assembler
; by Maciej Guba.
; http://macgub.co.pl



ROUND2 equ 10

;----Procedure render Phongs shaded triangle with -------
;----arbitrary color given. -----------------------------

; first stage - look at 'glass_tex_tri' proc

real_phg_line_col:

     shufps  xmm3,xmm5,00100010b
     shufps  xmm3,xmm3,11101000b

; in:
;    xmm0 - normal vector 1
;    xmm1 - normal vect 2
;    xmm3 - lo -> hi z1, z2 coords as dwords floats
;    xmm2 - lo -> hi y_min, y_max, x_min, x_max
;           as dword integers
;    xmm4 - normalized light vector
;    mm0 - col 0x00rrggbb
;    eax - x1
;    ebx - x2
;    ecx - y
;    edi - screen buffer
;    esi - z/stencil buffer filled with dd floats

   push  ebp
   mov   ebp,esp
   sub   esp,256
   sub   ebp,16
   and   ebp,0xfffffff0

 .n1  equ [ebp-16]
 .n2  equ [ebp-32]
 .col equ [ebp-48]
 .lx1 equ [ebp-52]
 .lx2 equ [ebp-56]
 .z2  equ [ebp-60]
 .z1  equ [ebp-64]
 .screen  equ [ebp-68]
 .zbuff   equ [ebp-72]
 .x_max   equ [ebp-74]
 .x_min   equ [ebp-76]
 .y_max   equ [ebp-78]
 .y_min   equ [ebp-80]
 .dn      equ [ebp-96]
 ;.dz      equ [ebp-100]
 ;.y       equ [ebp-104]
 .dz      equ [ebp-112]
 .y       equ [ebp-116]


 .t_one   equ [ebp-32]
 .dot_pr  equ [ebp-16]

        mov     .y,ecx
        packssdw xmm2,xmm2
        movq    .y_min,xmm2
        cmp     cx,.y_min
        jl      .end_rp_line
        cmp     cx,.y_max
        jge     .end_rp_line          ;

        cmp     eax,ebx
        je      .end_rp_line
        jl      @f
        xchg    eax,ebx
        movaps  xmm7,xmm0
        movaps  xmm0,xmm1
        movaps  xmm1,xmm7
        shufps  xmm3,xmm3,11100001b
   @@:

        cmp     ax,.x_max
        jge     .end_rp_line
        cmp     bx,.x_min
        jle     .end_rp_line
        movaps  .n1,xmm0
        movaps  .n2,xmm1
        mov     .lx1,eax
        mov     .lx2,ebx
        movlps  .z1,xmm3

        sub     ebx,eax
        cvtsi2ss xmm7,ebx
        rcpss   xmm7,xmm7
        shufps  xmm7,xmm7,0
        subps   xmm1,xmm0
        mulps   xmm1,xmm7
        movaps  .dn,xmm1
        psrldq  xmm3,4
        subss   xmm3,.z1
        mulss   xmm3,xmm7
        movss   .dz,xmm3



        mov      ebx,.lx1
        cmp      bx,.x_min     ; clipping on function4
        jge      @f
        movzx    eax,word .x_min
        sub      eax,ebx
        cvtsi2ss xmm7,eax
        shufps   xmm7,xmm7,0
        mulss    xmm3,xmm7
        mulps    xmm1,xmm7
        addss    xmm3,.z1
        addps    xmm1,.n1
        movsx    eax,word .x_min
        movss    .z1,xmm3
        movaps   .n1,xmm1
        mov      dword .lx1,eax

      @@:
        movzx   eax,word .x_max
        cmp     .lx2,eax
        jl      @f
        mov     .lx2,eax
      @@:
        movzx   eax,word[xres_var]
        mul     dword .y
      ;  mov     edx,.x1
        add     eax,.lx1
        shl     eax,2
        add     edi,eax
        add     esi,eax

        mov     ecx,.lx2
        sub     ecx,.lx1
        xorps     xmm0,xmm0
        movq2dq   xmm3,mm0
        punpcklbw xmm3,xmm0  ;[the_zero]
        punpcklwd xmm3,xmm0  ;[the_zero]
        cvtdq2ps  xmm3,xmm3
        movaps    .col,xmm3

        movaps  xmm0,.n1
        movss   xmm2,.z1
        movaps  xmm4,[zero_hgst_dd]  ; global
        movaps  xmm3,[mask_65535f]
        mov     .t_one,dword 1.0
        mov     ebx,4
        mov     edx,lights_aligned_end
   .ddraw:
        movaps   xmm7,xmm2
        movaps   xmm6,xmm2
        addps    xmm7,.t_one
        subps    xmm6,.t_one
        cmpnltss xmm7,dword[esi]
        cmpnltss xmm6,dword[esi]
        xorps    xmm6,xmm7
        movd     eax,xmm6
        or       eax,eax
        jz       .skip
        movaps   xmm7,xmm0
        mulps    xmm7,xmm7 ; normalize
        haddps   xmm7,xmm7
        haddps   xmm7,xmm7
        rsqrtps  xmm7,xmm7
        mulps    xmm7,xmm0
        movaps   xmm6,xmm7

        mov      eax,lights_aligned    ; lights - global variable
        xorps    xmm1,xmm1     ; instead global can be used .lv - light vect.
      .again_col:
        movaps   xmm7,[eax]
        andps    xmm7,xmm4  ;[zero_hgst_dd]  ; global

        mulps    xmm7,xmm6  ;.cnv  ;.lv  ; last dword should be zeroed
        haddps   xmm7,xmm7
        haddps   xmm7,xmm7
        movaps   xmm5,xmm7 ; broadcasted dot product


        mulps    xmm7,xmm7
        mulps    xmm7,xmm7
        mulps    xmm7,xmm7
        mulps    xmm7,[eax+48]
     .no_reflective:
      ;  movups   xmm5,.dot_pr
        mulps    xmm5,[eax+16]
        addps    xmm5,[eax+32]
        addps    xmm5,xmm7
        mulps    xmm5,.col

        minps    xmm5,xmm3
        maxps    xmm1,xmm5
        add      eax,64
        cmp      eax,edx  ;lights_aligned_end    ; global
        jnz      .again_col
        cvtps2dq xmm1,xmm1
        packssdw xmm1,xmm1
        psrlw    xmm1,8
        packuswb xmm1,xmm1
        movd     [edi],xmm1
     .skip:
        add      edi,ebx
        add      esi,ebx
        addps    xmm0,.dn
        addps    xmm2,.dz
        dec      ecx
        jnz      .ddraw
      ;  loop     .ddraw

  .end_rp_line:
        add      esp,256
        pop      ebp

ret
