ROUND2 equ 10

slices_tri_var:
;  Procedure calculate variable slices  buffer, wich describes depth
;  history of each filled screen pixel. It means pixel, that has not
;  zeroed counter in counter buff.
;  ----------------in - eax - x1 shl 16 + y1 -----------------------
;  -------------------- ebx - x2 shl 16 + y2 -----------------------
;  -------------------- ecx - x3 shl 16 + y3 -----------------------
; --------------------- edi - pointer to var sli pointers buff -----
; --------------------- esi - pointer to counter buffer ------------
;  -------------------- xmm0 - lo -> hi z1, z2, z3 as dword float --
;---------------------- xmm5 - lo -> hi y_min, y_max, x_min, x_max -
;-                      as dword integers --------------------------
.stvx1     equ [ebp-2]
.stvy1     equ [ebp-4]
.stvx2     equ [ebp-6]
.stvy2     equ [ebp-8]
.stvx3     equ [ebp-10]
.stvy3     equ [ebp-12]
.hlp2      equ [ebp-14]

.stvdx12   equ dword[ebp-20]
.stvdx13   equ dword[ebp-24]
.stvdx23   equ [ebp-28]
.stvdz12   equ dword[ebp-32]
.stvdz13   equ [ebp-36]
.stvdz23   equ [ebp-40]
.stvzz2    equ [ebp-44]
.stvzz1    equ [ebp-48]
.stvz3     equ [ebp-56]
.stvz2     equ [ebp-60]
.stvz1     equ [ebp-64]
.stvptr_buff equ [ebp-68] ; buffer of pointers, points on slices
.stvcnt_buff equ [ebp-72]
.x_max       equ [ebp-84]
.x_min       equ [ebp-88]
.y_max       equ [ebp-92]
.y_min       equ [ebp-96]


       push    ebp
       mov     ebp,esp

      .stvsort2:
        cmp     ax,bx
        jle     .stvsort1
        xchg    eax,ebx
        shufps  xmm0,xmm0,11100001b
      .stvsort1:
        cmp     bx,cx
        jle     .stvsort3
        xchg    ebx,ecx
        shufps  xmm0,xmm0,11011000b
        jmp     .stvsort2
      .stvsort3:

           ; store triangle coordinates in user friendly variables
        push    eax ebx ecx

        sub     esp,100
        movups  .stvz1,xmm0
        movaps  xmm1,xmm0


        mov     .stvptr_buff,edi
        movdqu   .y_min,xmm5

        xorps     xmm2,xmm2
        xorps     xmm4,xmm4
        movups    xmm0,.stvy3
        movups    xmm3,.hlp2
        psrld     xmm0,16     ; cut
        psrld     xmm3,16
        pcmpgtw   xmm4,xmm0
        pcmpgtw   xmm2,xmm3

        pslldq    xmm4,2
        pslldq    xmm2,2

        por       xmm0,xmm4
        por       xmm3,xmm3

        movaps    xmm2,xmm0
        movaps    xmm4,xmm3

        shufps    xmm0,xmm0,11101001b
        shufps    xmm2,xmm2,11010000b
        psubd     xmm2,xmm0
        cvtdq2ps  xmm2,xmm2


        shufps    xmm3,xmm3,11101001b
        shufps    xmm4,xmm4,11010000b
        psubd     xmm4,xmm3
        cvtdq2ps  xmm4,xmm4

        mov       eax,1 shl ROUND2
        cvtsi2ss  xmm5,eax
        shufps    xmm5,xmm5,0
        mulps     xmm2,xmm5

        rcpps     xmm4,xmm4
        mulps     xmm2,xmm4


        cvtps2dq  xmm2,xmm2

        movaps    xmm0,xmm1
        shufps    xmm0,xmm0,11011010b
        shufps    xmm1,xmm1,11000001b
        subps     xmm0,xmm1
        mulps     xmm0,xmm4
        movups    .stvdz23,xmm0

        movups    .stvdx23,xmm2


        mov      edx,.stvz1

        mov     .stvzz1,edx
        mov     .stvzz2,edx
        movlps  xmm0,.stvzz1
        movsx   eax,word .stvx1
        shl     eax,ROUND2    ; eax - cur x1
        mov     ebx,eax       ; ebx - cur x2

        mov     cx,.stvy1
        cmp     cx,.stvy2
        jge     .stvloop1_end
     .stvloop1:

        pushad
        sar     ebx,ROUND2
        sar     eax,ROUND2
        movups  xmm2,.y_min
        mov     edx,.stvptr_buff
        call    st_sl_var_line

        popad
        add     eax,.stvdx13
        add     ebx,.stvdx12


        movlps  xmm0,.stvzz1
        movlps  xmm2,.stvdz13
        addps   xmm0,xmm2
        movlps  .stvzz1,xmm0

        inc     ecx
        cmp     cx,.stvy2
        jl      .stvloop1

    .stvloop1_end:

        mov     edx,.stvz2
        mov     .stvzz2,edx
        movsx   ebx,word .stvx2
        shl     ebx,ROUND2

        mov     cx,.stvy2
        cmp     cx,.stvy3
        jge     .stvloop2_end
     .stvloop2:
        pushad

        sar     ebx,ROUND2
        sar     eax,ROUND2
        movlps  xmm0,.stvzz1
        movups  xmm2,.y_min
        mov     edx,.stvptr_buff

        call    st_sl_var_line

        popad

        add     eax,.stvdx13
        add     ebx,.stvdx23

        movss   xmm1,.stvzz1
        movss   xmm2,.stvzz2
        addss   xmm1,.stvdz13
        addss   xmm2,.stvdz23
        movss   .stvzz1,xmm1
        movss   .stvzz2,xmm2


        inc     ecx
        cmp     cx,.stvy3
        jl      .stvloop2
     .stvloop2_end:

        mov  esp,ebp
        pop  ebp

ret

st_sl_var_line:
;----------------------------------------------------
;-------------in xmm0 - lo -> hi z1, z2 -------------
;----------------xmm2 - lo -> hi y_min, y_max, x_min,
;---------------- x_max as dword integers -----------
;--------------- eax - x1 ---------------------------
;--------------- ebx - x2 ---------------------------
;--------------- ecx - y-----------------------------
;--------------- esi - pointer to cnt buff ----------
; -------------- edx - pointer to ptr buff ----------


.slvdz  equ  [ebp-4]
.slvz2  equ  [ebp-8]
.slvz1  equ  [ebp-12]
.slvx2  equ  [ebp-16]
.slvx1  equ  [ebp-20]
.slvptr_buff equ [ebp-24]
.slvcnt_buff equ [ebp-28]
.slvtop_ptr  equ [ebp-32]
.x_max  equ [ebp-34]
.x_min  equ [ebp-36]
.y_max  equ [ebp-38]
.y_min  equ [ebp-40]
;.sli_buff equ [ebp-36]


     push       ebp
     mov        ebp,esp
     sub        esp,64

     packssdw   xmm2,xmm2
     movq       .y_min,xmm2

     cmp        cx,.y_min
     jl         .l_quit

     cmp        cx,.y_max   ;[yres_var]
     jge        .l_quit
;     packssdw   xmm2,xmm2
;     movq       .y_min,xmm2
;     cmp        cx,.y_min
;     jl         .l_quit
;     cmp        cx,.y_max
;     jge        .l_quit          ;
     movzx      ecx,cx
     mov        .slvcnt_buff,esi
     mov        .slvptr_buff,edx
     cmp        eax,ebx
     je         .l_quit
     jl         .l_ok

     xchg       eax,ebx
     shufps     xmm0,xmm0,11100001b
   .l_ok:

     cmp        ax,.x_max
     jge        .l_quit
     cmp        bx,.x_min
     jle        .l_quit

     movlps     .slvz1,xmm0
     mov        .slvx1,eax
     mov        .slvx2,ebx

     sub        ebx,eax
     movss      xmm0,.slvz2
     cvtsi2ss   xmm1,ebx
     rcpss      xmm1,xmm1
     subss      xmm0,.slvz1
     mulss      xmm0,xmm1
     movss      .slvdz,xmm0

     movzx      edx,word .x_max
     mov        ebx, .slvx1
     cmp        bx, .x_min
     jge        @f              ; clipping
     movzx      eax,word .x_min
     sub        eax,ebx
     cvtsi2ss   xmm2,eax
     mulss      xmm2,.slvdz
     addss      xmm2,.slvz1
     movss      .slvz1,xmm2
     movzx      eax, word .x_min
     mov        dword .slvx1,eax
;     movzx      edx,word[.x_max]
;     sub        edx,1
   @@:
     cmp        .slvx2,edx
     jl         @f
     mov        .slvx2,edx

    @@:
 ;   mov         eax,.x1
 ;   cmp         .x2,eax
 ;   je          .l_quit
     movzx      edx,word[xres_var]
     mov        edi,.slvptr_buff
     mov        esi, [slices_counter_ptr] ; .cnt_buff
     mov        eax,ecx  ; y
     mul        edx
     add        eax,.slvx1
     add        esi,eax
     shl        eax,2
     add        edi,eax

     mov        ecx,.slvx2
     sub        ecx,.slvx1
     movss      xmm2,.slvz1   ; cz

   .ccalc:
     movzx     ebx,byte[esi]
     or        ebx,ebx       ; inpossible ?
     jz        .update_counters
     mov       edx,[edi]
   .next_sli:
     movss     xmm0,xmm2
     cmpltss   xmm0,[edx]
     movd      eax,xmm0
     cmp       eax,-1
     jne       .update_sli
     mov       eax,edx    ; eax - top
    ; now shift dword variable in [edx]  ebx-1   times
     dec       ebx
     jz        .ins_new
     shl       ebx,2
     add       edx,ebx
   @@:
     push      dword[edx-4]
     pop       dword[edx]
     sub       edx,4
     cmp       edx,eax
     jnz       @b
   .ins_new:
     movss     [eax],xmm2  ; insert new value
     jmp       .update_counters
   .update_sli:
     add       edx,4
     dec       ebx
     jnz       .next_sli

 .update_counters:
     add       edi,4
     inc       esi
     addss     xmm2,.slvdz
     loop       .ccalc

  .l_quit:
     mov       esp,ebp
     pop       ebp
ret
