
ROUND equ 8

;------------------------------------------------------------------------------
;- Procedure drawing textured horizontal line using Catmull Z-buffer algorithm
;------------------------------------------------------------------------------
; first stage triangle render proc - see file bump_tex_inc
textured_line_z:
;-----in -edi screen buffer pointer
;------------ stack:


;	 xmm0 - .ty1, .tx1, .ey1, ex1
;	 xmm1 - .ty2, .tx2, .ey2, ex2
;	 xmm2 - .by1, .bx1, .z1, x1
;	 xmm3 - .by2, .bx2, .z2, x2
;
;--------------in: eax - x1
;--------------    ebx - x2
;--------------    edi - pointer to screen buffer

;stack - another parameters:

.y	 equ dword [ebp+4+4]
.bmap	 equ dword [ebp+8+4]	    ; bump map pointer
.emap	 equ dword [ebp+12+4]	    ; env map pointer
.z_buff  equ dword [ebp+16+4]	    ; z buffer
.tex_map equ dword [ebp+20+4]	   ; texture pointer
.y_min	 equ  [ebp+24+4]
.y_max	 equ  [ebp+26+4]



  .x1	   equ	[ebp-4]
  .x2	   equ	[ebp-8]
  .tex_dx  equ dword [ebp-12]
  .tex_dy  equ dword [ebp-16]
  .dz	   equ dword [ebp-20]
  .cz	   equ dword [ebp-24]
  .c_tex_x equ dword [ebp-28]  ; current tex x
  .tex_x1  equ [ebp-32]
  .tex_y1  equ [ebp-36]
  .tex_x2  equ [ebp-40]
  .tex_y2  equ [ebp-44]
  .z2	   equ [ebp-48]
  .z1	   equ [ebp-52]



	push	ebp
	mov	ebp,esp
	mov	edx,.y
	cmp	dx,.y_min  ;ax
	jl	.ttl_quit
	cmp	dx,.y_max  ;;[yres_var]   ;SIZE_Y
	jge	.ttl_quit
      ;  int3
	movaps	xmm5,xmm2
	movhlps xmm5,xmm3  ; l-h: cz2, xx, cz1, xx
	shufps	xmm5,xmm5, 11110010b

	 ; xm2 - z1, z2
	cmp	 eax,ebx
	je	.ttl_quit
	jl	.ttl_ok

	xchg	eax,ebx
	movaps	xmm7,xmm0
	movaps	xmm0,xmm1
	movaps	xmm1,xmm7
	shufps	xmm5,xmm5, 11110001b


     .ttl_ok:
	push	eax
	push	ebx
	sub	esp,50
	mov	dx,[xres_var]
	cmp	ax,dx
	jge	.ttl_quit
	cmp	ebx,0
	jle	.ttl_quit

	sub	ebx,eax  ;.x1
	movq	.tex_y1,xmm0
	movq	.tex_y2,xmm1
	movq	.z1,xmm5

	mov	eax,dword .tex_y2	; calc .dty
	sub	eax,dword .tex_y1
	cdq
	idiv	ebx
	mov    .tex_dy,eax

	mov	eax,dword .tex_x2	; calc .dtx
	sub	eax,dword .tex_x1
	cdq
	idiv	ebx
	mov	.tex_dx,eax

	mov	eax,.z2       ; calc .dz
	sub	eax,.z1
	cdq
	idiv	ebx
	mov	.dz,eax
	xor	edx,edx

	cmp    dword .x1, edx	       ; clipping
	jg     @f

	mov	ebx, .x1
	neg	ebx
	imul	ebx	      ; eax = .dz * abs(.x1)
	add	.z1,eax
	mov	dword .x1, 0

	mov	eax,.tex_dy
	imul	ebx
	add	dword .tex_y1,eax

	mov	eax,.tex_dx
	imul	ebx
	add	dword .tex_x1,eax

      @@:
	movzx	eax,[xres_var]
	cmp	.x2,eax
	jl	@f
	mov	.x2,eax
      @@:

	mov	ebx,.y	      ; calc mem begin in buffers
	movsx	eax,[xres_var] ;SIZE_X
	mul	ebx
	mov	ebx, .x1
	add	eax,ebx
	shl	eax,2

	add	edi,eax 	       ; edi - scr buff
	add	.z_buff,eax	       ; z buffer pointer


	mov	ecx,.x2
	sub	ecx,.x1
      ;  mov	 edx,.z1
	mov	eax,dword .tex_x1
	mov	ebx,dword .tex_y1
     ;	 mov	 .cz,edx
	mov	.c_tex_x,eax
      ;  push	 dword .z1	     ; .cz
      ;  push	 eax		     ;.c_tex_x

	mov	 edx,.z_buff
	cld

     .ttl_loop:
						;  eax - temp
	mov	eax,.z1 			;  ebx - cur tex y shl ROUND
	cmp	eax,[edx]			;  ecx - l.lenght
	jge	@f			; ebx - cur tex_y ;  edx - temp
	mov	esi,ebx 		;  edi - scr buff
	sar	esi,ROUND		;  esi - tex_ptr temp
	shl	esi,TEX_SHIFT		;  .z_ptr - cur pointer to z buff
	mov	eax,.c_tex_x		;  .cz - cur z coord shl CATMULL_SHIFT
	sar	eax,ROUND
	add	esi,eax
	mov	eax,.z1
	mov	dword[edx],eax		; renew z buffer

	and	esi,TEXTURE_SIZE
	shl	esi,2
	add	esi,.tex_map

	lodsd
	mov	[edi],eax

      @@:
	add	edi,4
	add	edx,4

	mov	eax,.dz
	add	.z1,eax
	mov	eax,.tex_dx
	add	.c_tex_x,eax
	add	ebx,.tex_dy
	loop	.ttl_loop

 .ttl_quit:

	mov	esp,ebp
	pop	ebp

ret 24	;30+8+4
