
;------- Big thanks to Majuma (MIKOLaj Feliks) for absolutely great- ----
;------- DOS 13h mode demos ---------------------------------------------
;------- Procedure draws horizontal line with two overlapped textures. --
;--------I use Catmull Z-buffer algorithm- (Z coordinate interpolation)--
;--------I calc texture pixel by this way: col1*col2/256 ----------------
two_tex_line_z:

;--------------in: eax - x1
;--------------    ebx - x2
;--------------    edi - pointer to screen buffer

;	 xmm0 - .ty1, .tx1, .ey1, ex1
;	 xmm1 - .ty2, .tx2, .ey2, ex2
;	 xmm2 - .by1, .bx1, .z1, x1
;	 xmm3 - .by2, .bx2, .z2, x2
;	 stack - another parameters :


.y	 equ dword [ebp+4]
.bmap	 equ dword [ebp+8]	  ; bump map pointer
.emap	 equ dword [ebp+12]	  ; env map pointer
.z_buff  equ dword [ebp+16]	  ; z buffer
.tex_map equ dword [ebp+20]	  ; texture pointer
.y_min	 equ	   [ebp+24]
.y_max	 equ	   [ebp+26]


.x1	equ dword [ebp-4]
.x2	equ dword [ebp-8]
.dbx	equ	  [ebp-12]
.dex	equ	  [ebp-16]
.dby	equ	  [ebp-20]
.dey	equ	  [ebp-24]
.dz	equ dword [ebp-28]
.cbx	equ	  [ebp-32]
.cex	equ	  [ebp-36]
.cby	equ	  [ebp-40]
.cey	equ	  [ebp-44]
.cz	equ dword [ebp-48]
.czbuff equ dword [ebp-52]
.bx1	equ	  [ebp-56]
.ex1	equ	  [ebp-60]
.by1	equ	  [ebp-64]
.ey1	equ	  [ebp-68]
.z2	equ	  [ebp-72]
.z1	equ	  [ebp-76]


	mov	ebp,esp

	mov	ecx,.y
	cmp	cx,.y_min
	jl	.bl_end
	cmp	cx,.y_max  ;SIZE_Y
	jge	.bl_end
	movaps	xmm5,xmm2
	movhlps xmm5,xmm3  ; l-h: cz2, xx, cz1, xx
	shufps	xmm5,xmm5, 11110010b

	cmp	eax,ebx
	jl	@f
	je	.bl_end

	xchg	eax,ebx

	movaps	xmm7,xmm0
	movaps	xmm0,xmm1
	shufps	xmm5,xmm5, 11110001b
	movaps	xmm1,xmm7

    @@:
	push	eax
	push	ebx	      ;store x1, x2
	movsx	ebx,[xres_var]
	cmp	.x1,ebx
	jge	.bl_end
	cmp	.x2,0
	jle	.bl_end

	mov	ebx,.x2
	sub	ebx,.x1

     ; sse  to avoid many divisions
       sub	 esp,80  ;16
       shufps	 xmm1,xmm1,11011000b
       shufps	 xmm0,xmm0,11011000b
       movups	 .ey1,xmm0
       movlps	 .z1,xmm5

       cvtsi2ss  xmm3,ebx
       rcpss	 xmm3,xmm3
       shufps	 xmm3,xmm3,0

       psubd	 xmm1,xmm0
       cvtdq2ps  xmm1,xmm1
       mulps	 xmm1,xmm3
    ;	shufps	  xmm1,xmm1,11011000b
       cvtps2dq  xmm1,xmm1
       movdqu	 .dey,xmm1


	mov	eax,.z2        ; calc .dz
	sub	eax,.z1
	cdq
	idiv	ebx
	mov	.dz,eax
     ;	 push	 eax

	cmp	.x1,0	      ; set correctly begin variable
	jge	@f	      ; CLIPPING ON FUNCTION
			      ; cutting triangle exceedes screen
	mov	ebx,.x1
	neg	ebx
	imul	ebx	      ; eax = .dz * abs(.x1)
	add	.z1,eax
	mov	.x1,0

	mov	eax,.dbx
	imul	ebx
	add    .bx1,eax

	mov	eax,.dby
	imul	ebx
	add	.by1,eax

	mov	eax,.dex
	imul	ebx
	add	.ex1,eax

	mov	eax,.dey
	imul	ebx
	add	.ey1,eax
      @@:
	movsx	eax,[xres_var]
	cmp	.x2,eax  ;SIZE_X
	jl	@f
	mov	.x2,eax  ;SIZE_X
      @@:
    ;	 mov	 eax,SIZE_X	  ;calc memory begin in buffers
	mov	ebx,.y
	mul	ebx
	mov	ebx,.x1
	add	eax,ebx
	shl	eax,2
	add	edi,eax 	   ; edi - screen
 ;	 mov	 esi,.z_buff	   ; z-buffer filled with dd variables
	add	.z_buff,eax

	mov	ecx,.x2
	sub	ecx,.x1

	; init current variables

			     ; hi - lo -> cbx; cex
	movups	 xmm4,.ey1  ;[esp]  ; .cey   ; hi - lo -> cby; cey
	movups	 xmm6,.dey
	mov	 edx,.z_buff ;1  ;.czbuff
	pxor	 xmm0,xmm0

     .draw:

	mov	ebx,.z1 ;cz
	cmp	ebx,dword[edx]
	jge	.skip

	movaps	xmm1,xmm4
	psrad	xmm1,ROUND
	movhlps xmm2,xmm1
	pslld	xmm1,TEX_SHIFT
	paddd	xmm2,xmm1
	movd	ebx,xmm2
	and	ebx,TEXTURE_SIZE
	psrlq	xmm2,32
	movd	esi,xmm2
	and	esi,TEXTURE_SIZE
	lea	ebx,[ebx*4]
	add	ebx,.tex_map
	lea	esi,[esi*4]	    ;-	; esi - current b. texture addres
	add	esi,.emap


	movd	  xmm1,[esi]
	movd	  xmm2,[ebx]
	punpcklbw xmm1,xmm0
	punpcklbw xmm2,xmm0
	pmullw	  xmm1,xmm2
	psrlw	  xmm1,8
	packuswb  xmm1,xmm0
	movd	  [edi],xmm1
	mov	  ebx,.z1
	mov	  dword[edx],ebx
     .skip:
	add	edi,4
	add	edx,4
	paddd	xmm4,xmm6 ;.dey
	mov	eax,.dz
	add	.z1,eax

	loop	.draw

  .bl_end:
	mov	esp,ebp
ret 24	;60





