

;  rotary about arbitrary vector implemented by Maciej Guba,
;  macgub3@wp.pl , http://macgub.co.pl
;  ebx - normalized vector 3 dwords, each dword coefficient
;  esi - cosinus and sinus of angle
;  edi - desired matrix


make_arbitrary_mx:
 .nx	  equ [ebx]
 .ny	  equ dword[ebx+4]
 .nz	  equ dword[ebx+8]
 .sinus   equ [esi]
 .cosinus equ dword[esi+4]

if 0

 movups  xmm0,.nx
 movlps  xmm1,.sinus
 movlhps xmm1,xmm1
 movaps  xmm2,xmm0
 movaps  xmm3,xmm0
 shufps  xmm2,xmm2,01000000b  ;       ny   nx  nx  nx
 shufps  xmm3,xmm3,10011001b  ;       nz   ny  nz  ny
 movaps  xmm4,[the_one]
 movaps  xmm5,xmm1
 movaps  xmm6,xmm4
 mulps	 xmm2,xmm3

 shufps  xmm5,xmm5,01010101b  ;       cos cos cos cos
 subps	 xmm6,xmm5 ; 1.0 - cos
 mulps	 xmm6,xmm2

 movaps  xmm2,xmm0
 shufps  xmm2,xmm2,00100110b   ;  nx nz ny nz
 movaps  xmm3,xmm1
 shufps  xmm3,xmm3,00000000b   ; sin sin sin sin
 mulps	 xmm3,xmm2
 movaps  xmm5,xmm6
 addps	 xmm6,xmm3
 subps	 xmm5,xmm3
 movss	 [edi+4],xmm5
 shufps  xmm6,xmm6,00111001b
; psrldq  xmm6,4
; psrldq  xmm5,12
 shufps  xmm5,xmm5,11111111b
 movlps  [edi+8],xmm6	       ; +20 +12 +8 +4
 shufps  xmm3,xmm3,11111111b
; psrldq  xmm3,12
 movss	 [edi+20],xmm5

 movaps  xmm3,xmm0
 movaps  xmm2,xmm1
 shufps  xmm2,xmm2,01010101b  ; cos cos cos cos
 mulps	 xmm3,xmm3	      ; xx  nz	ny  nx
 movaps  xmm5,[the_one] ;xmm4
 subps	 xmm5,xmm3

 mulps	 xmm5,xmm2
 addps	 xmm3,xmm5
 movss	 [edi],xmm3	      ; +32 +16 +0
 psrldq  xmm3,4
 movss	 [edi+16],xmm3
 psrldq  xmm3,4
 movss	 [edi+32],xmm3

end if

if 0

 shufps  xmm2,xmm0,11111010b ; nz nz
 movaps  xmm5,xmm0	     ; ny nx
 movaps  xmm6,[the_one]  ;xmm4		 ; 1.0 1.0
 shufps  xmm7,xmm1,11110101b ; cos cos
 mulps	 xmm5,xmm2
 subps	 xmm6,xmm7
 mulps	 xmm6,xmm5

 shufps  xmm7,xmm0,11110001b ; nx  ny
 shufps  xmm5,xmm1,11110000b ; sin sin
 mulps	 xmm7,xmm5
; movss   xmm1,[sign_mask]
; int3
; shufps  xmm1,xmm1,11111100b ; +   -
; xorps   xmm7,xmm1
 movaps   xmm5,xmm6
 addps	  xmm6,xmm7
 subps	  xmm5,xmm7
 psrldq   xmm6,4
 movss	  [edi+24],xmm5
 movss	  [edi+28],xmm6

end if

 fninit

if 1  ; 0
 fld	dword[ebx]
 fmul	st,st0
 fld	st
 fchs
 fld1
 faddp
 fmul	.cosinus ; dword[esi]
 faddp
 fstp	dword[edi]
end if

if 1  ;0

 fld	dword .nx
 fmul	.ny
 fld	.cosinus
 fchs
 fld1
 faddp
 fmulp
 fld	.nz ;dword[ebx+8]
 fmul	dword .sinus  ;dword[esi]
; fchs
 faddp
 fstp	dword[edi+4]

 fld	dword .nx
 fmul	.nz
 fld1
 fld	.cosinus
 fchs
 faddp
 fmulp
 fld	.ny
 fmul	dword .sinus
 fchs
 faddp
 fstp	dword[edi+8]
end if

if 1
 fld	dword .nx
 fmul	.ny
 fld1
 fld	.cosinus
 fchs
 faddp
 fmulp
 fld	dword .sinus
 fmul	.nz
 fchs
 faddp
 fstp	dword[edi+12]
end if

if 1

 fld	.ny
 fmul	st,st0
 fld	st
 fchs
 fld1
 faddp
 fmul	.cosinus
 faddp
 fstp	dword[edi+16]
end if

if 1

 fld	.ny
 fmul	.nz
 fld1
 fld	.cosinus
 fchs
 faddp
 fmulp
 fld	dword .sinus
 fmul	dword .nx
; fchs
 faddp
 fstp	dword[edi+20]
end if

if 1
 fld	dword .nx
 fmul	.nz
 fld1
 fld	.cosinus
 fchs
 faddp
 fmulp
 fld	.ny
 fmul	dword .sinus
; fchs
 faddp
 fstp	dword[edi+24]
end if
if 1
 fld	.ny
 fmul	.nz
 fld1
 fld	.cosinus
 fchs
 faddp
 fmulp
 fld	dword .nx
 fmul	dword .sinus
 fchs
 faddp
 fstp	dword[edi+28]

end if

if 1
 fld	.nz
 fmul	st,st0
 fld	st
 fchs
 fld1
 faddp
 fmul  .cosinus
 faddp
 fstp  dword[edi+32]
end if

ret



;sign_m:
;the_one:
