


; Line drawing procedure by Pablo Reda.
; Some changes by Maciej Guba.
;******************************************* 
linea1:  ; eax=x1 ebx=y1 ecx=x2 edx=y2
	    ; mm1  - screen buffer
	    ; mm2  - screen width
	    ; mm3  - color 0x00rrggbb
	    ; mm4  - screen size in bytes
	    ; xmm7 - max x, max y
	    ; xmm6 - min x, min y

	 movlhps   xmm7,xmm7
	 movlhps   xmm6,xmm6
	 paddd	   xmm6,[i1x4]
	 psubd	   xmm7,[i1x4]
	 movd	   xmm0,eax
	 movd	   xmm1,ebx
	 movd	   xmm2,ecx
	 movd	   xmm3,edx
	 pslldq    xmm1,4
	 pslldq    xmm2,8
	 pslldq    xmm3,12
	 por	   xmm0,xmm1
	 por	   xmm0,xmm2
	 por	   xmm0,xmm3
	 movdqa    xmm1,xmm0
	 movdqa    xmm2,xmm0
	 pcmpgtd   xmm1,xmm7
	 pcmpgtd   xmm0,xmm6
	 pxor	   xmm1,xmm0
	 movmskps  edi,xmm1
	 cmp	   edi,0xf
	 jne	   .end



	cmp ebx,edx
	je horizontal 
	jg .noswap 
	xchg eax,ecx 
	xchg ebx,edx 
.noswap:
	cmp eax,ecx
	shl eax,16
	shl ecx,16 
	sub eax,ecx 
	push ebx 
	push edx 
	sub ebx,edx 
	add ebx,1 
	cdq 
	idiv ebx 
	mov esi,eax 
	add ecx,$7fff 
	pop ebx 
	pop edx 
.lineas: 
	mov eax,ecx 
	add eax,esi 
	push ebx 
	push eax 
	shr ecx,16 
	shr eax,16 
	call horizontal 
	pop ecx 
	pop ebx 
	add ebx,1 
	cmp ebx,edx 
	jle .lineas
.end:
	ret

horizontal:  ; eax=x1 ebx=y1 ecx=x2 
	cmp ecx,eax 
	jg .m 
	xchg ecx,eax 
.m: 
	sub ecx,eax 
	jnz .nn
	inc ecx
.nn:
	push edx
	movd  edx,mm2
	imul ebx,edx	; mm2 - screen_width_var
	pop  edx
	add eax,ebx
	movd  edi,mm1	; mm1 - line_buffer_var
	lea edi,[edi+eax*4]
.l:
	movd [edi],mm3	; mm3 - color
	add edi,4
	loop .l
	ret





;---------------------------------------------------------

line_sse:	; sse poor version
	    ; eax=x1 ebx=y1 ecx=x2 edx=y2
	    ; xmm1  - screen buffer
	    ; xmm2  - screen width
	    ; xmm3  - color 0x00rrggbb
	    ; xmm4  - coords dd pack
	    ; xmm5 -  max x, max y, min x min y




    ;	  movaps  xmm6,xmm5
    ;	  movlhps xmm6,xmm6   ; max
    ;	  movhlps xmm5,xmm5   ; min
    ;	  movaps  xmm7,xmm4
    ;	  pcmpgtd xmm7,xmm5
    ;	  pcmpgtd xmm4,xmm6
     ;	  pxor	  xmm4,xmm7
     ;	  pmovmskb esi,xmm4
     ;	  cmp	   esi,-1
     ;	  jz	   @f
     ;	  ret
      @@:


	cmp  ebx,edx
	je   hhorizontal
	jg   .noswap
	xchg eax,ecx 
	xchg ebx,edx 
.noswap:
	cmp  eax,ecx
	shl  eax,16
	shl  ecx,16
	sub  eax,ecx
	push ebx 
	push edx 
	sub  ebx,edx
	inc  ebx
	cdq 
	idiv ebx 
	mov  esi,eax
	add  ecx,$7fff
	pop  ebx
	pop  edx
.lineas: 
	mov  eax,ecx
	add  eax,esi
	push ebx 
	push eax 
	shr  ecx,16
	shr  eax,16
	call hhorizontal
	pop  ecx
	pop  ebx
	inc  ebx
	cmp  ebx,edx
	jle  .lineas
.end:
	ret

hhorizontal:  ; eax=x1 ebx=y1 ecx=x2
	cmp  ecx,eax
	jg   .m
	xchg ecx,eax 
.m: 
	sub  ecx,eax
	jnz  .nn
	inc  ecx
.nn:
	push  edx
	movd  edx,xmm2
	imul  ebx,edx	 ; mm2 - screen_width_var
	pop   edx
	add   eax,ebx
	movd  edi,xmm1	 ; mm1 - line_buffer_var
	lea   edi,[edi+eax*4]
.l:
	movd  [edi],xmm3  ; mm3 - color
	add   edi,4
	loop  .l
	ret

